<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * This module adds support for downloading electronicaly distributed goods
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Customer interface
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    0b0633768559e57d1124488556a9dbf71d865723, v62 (xcart_4_7_7), 2017-01-23 20:12:10, download.php, aim
 * @link       http://www.x-cart.com/
 * @see        ____file_see____
 */

require __DIR__.'/auth.php';

if (empty($active_modules['Egoods'])) {
    func_403(64);
}

func_set_time_limit(2700);

if (!empty($id)) {
    $download_data = func_query_first("SELECT productid,itemid,expires,userid FROM $sql_tbl[download_keys] WHERE download_key = '$id'");
}

if ($config['Egoods']['egoods_check_owner'] == 'Y') {
    require $xcart_dir . '/include/remember_user.php';

    if (empty($download_data) || !func_egoods_check_owner($download_data)) {
        func_403(106);
    }
}

x_load('files','backoffice');

if (empty($_GET['action']) || $_GET['action'] != 'get') {

    // Prepare the appearing of download page

    require $xcart_dir . '/include/common.php';

    if ($id) {

        $productid = $download_data['productid'];

        if ($productid) {

            x_load('product');

            $product_data = func_select_product($productid, $user_account['membershipid']);

            if(!empty($active_modules['Extra_Fields'])) {

                $extra_fields_provider = $product_data['provider'];
                // to disable assert
                $variants = !empty($variants) ? $variants : array();
                $product_info = !empty($product_info) ? $product_info : $product_data;
                include $xcart_dir . '/modules/Extra_Fields/extra_fields.php';

            }

            $distribution     = $product_data['distribution'];

            $provider         = $product_data['provider'];

            if (is_url($distribution)) {

                $size = func_filesize($distribution, ($config['Egoods']['filesize_by_reading'] == 'Y'));

            } else {

                if (
                    !empty($provider)
                    && !$single_mode
                ) {

                    $provider_flag = func_query_first_cell("SELECT $sql_tbl[memberships].flag FROM $sql_tbl[customers], $sql_tbl[memberships] WHERE $sql_tbl[customers].id = '$provider' AND $sql_tbl[customers].membershipid = $sql_tbl[memberships].membershipid");

                    if ($provider_flag == 'RP')
                        $single_mode = true;

                }

                if (
                    empty($provider)
                    || $single_mode
                    || !empty($active_modules['Simple_Mode'])
                ) {

                    $distribution = $files_dir_name . $distribution;

                } else {

                    $distribution = func_get_files_location($provider, 'P') . $distribution;

                }

                $size = func_filesize($distribution);

            }

            $product_data['length'] = number_format($size, 0, '', ' ');

            $smarty->assign('product', $product_data);

            if (empty($QUERY_STRING)) {

                $smarty->assign('url', $xcart_catalogs['customer'] . "/download.php?id=$id&action=get");

            } else {

                $smarty->assign('url', $xcart_catalogs['customer'] . "/download.php?" . $QUERY_STRING . "&action=get");

            }

            if ($product_data['length'] > 0) {
                $smarty->assign(
                    'title_length',
                    func_get_langvar_by_name(
                        'lbl_file_size_extended',
                        array(
                            'length' => $product_data['length'],
                        )
                    )
                );

            }

        }

    }

    $location[] = array(func_get_langvar_by_name('lbl_download'), '');

    $smarty->assign('main',     'download');

    // Assign the current location line
    $smarty->assign('location', $location);

    func_display('customer/home.tpl', $smarty);

    exit;

}

if (empty($download_data)) {
    exit();
}
$res = $download_data;

// If there is corresponding key in database and not expired
if (
    count($res) > 0
    && $res['expires'] > XC_TIME
) {

    // check if there is valid distribution for this product
    $productid = $res['productid'];

    $result = func_query_first("SELECT p.distribution, pl.product, p.provider FROM $sql_tbl[products] AS p INNER JOIN $sql_tbl[products_lng_current] AS pl USING(productid) WHERE p.productid = '$productid'");

    $distribution     = $result['distribution'];
    $provider         = $result['provider'];

    $remote_file     = is_url($distribution);

    if (!$remote_file) {

        if (
            !empty($provider)
            && !$single_mode
        ) {

            $provider_flag = func_query_first_cell("SELECT $sql_tbl[memberships].flag FROM $sql_tbl[customers], $sql_tbl[memberships] WHERE $sql_tbl[customers].id = '$provider' AND $sql_tbl[customers].membershipid = $sql_tbl[memberships].membershipid");

            if ($provider_flag == 'RP')
                $single_mode = true;

        }

        if (
            empty($provider)
            || $single_mode
            || !empty($active_modules['Simple_Mode'])
        ) {

            $distribution = $files_dir_name . $distribution;

        } else {

            $distribution = func_get_files_location($provider, 'P') . $distribution;

        }

    } else {

        $distribution = strtr($distribution, array(" " => "%20"));

    }

    $fd = func_fopen($distribution, 'rb');

    if (
        $fd
        || (
            $remote_file
            && ($data = func_url_get($distribution))
        )
    ) {

        header("Content-Type: application/force-download");

        header("Content-Disposition: attachment; filename=\"" . basename($distribution) . "\"");

        header("Content-Length: " . func_filesize($distribution));

        if ($fd) {

            while (
                !feof($fd)
                && connection_status() == 0
            ) {

                print(fread($fd, 8192));

                flush();

            }

            fclose($fd);

        } else {

            print($data);

            flush();

        }

    } else {

        $top_message = array(
            'type'         => 'E',
            'content'     => func_get_langvar_by_name('txt_download_failed_msg'),
        );

        func_header_location("download.php?id=" . $id);

    }

} else {

    db_query("DELETE FROM $sql_tbl[download_keys] WHERE expires <= '" . XC_TIME . "'");

    // Assign the current location line
    $smarty->assign('location', $location);

    func_display('modules/Egoods/wrong_key.tpl', $smarty);
}

?>
