<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Common payment functions
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Payment
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    158f7d5ea605c65a0a35a35e25ef055a20972f73, v167 (xcart_4_7_8), 2017-05-18 18:51:58, func.payment.php, aim
 * @link       http://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }

define('X_PAYMENT_TRANS_ALREADY_CAPTURED', 1);
define('X_PAYMENT_TRANS_ALREADY_VOIDED', 2);
define('X_PAYMENT_TRANS_ALREADY_REFUNDED', 4);
define('X_PAYMENT_TRANS_ALREADY_ACCEPTED', 8);
define('X_PAYMENT_TRANS_ALREADY_DECLINED', 16);

define('PAYMENT_NEW_STATUS', 1);
define('PAYMENT_AUTH_STATUS', 2);
define('PAYMENT_DECLINED_STATUS', 3);
define('PAYMENT_CHARGED_STATUS', 4);

class XCPayment {
    const HUNDREDTH = 2;

    public static function usedPriceFormat() {//{{{
        global $config;
        return intval($config['Appearance']['number_format']{0});
    }//}}}

    public static function convertPricesToHundredth($cart) {//{{{
        $cart['total_cost'] = price_format($cart['total_cost'], 2);
        return $cart;
    }//}}}

    public static function addPayment($params)
    {//{{{
        global $sql_tbl;

        $_paymentid = func_array2insert('payment_methods', $params);
        if (empty($_paymentid)) {
            return false;
        }
        // zero raw to support inner joins
        db_query("REPLACE INTO $sql_tbl[pmethod_memberships] (paymentid,membershipid) VALUES ('$_paymentid','0')");
        return $_paymentid;
    }//}}}

    public static function deleteById($paymentid)
    {//{{{
        global $sql_tbl;
        $paymentid = intval($paymentid);

        db_query("DELETE FROM $sql_tbl[payment_methods] WHERE paymentid='$paymentid'");
        db_query("DELETE FROM $sql_tbl[pmethod_memberships] WHERE paymentid='$paymentid'");
        db_query("UPDATE $sql_tbl[ccprocessors] SET paymentid='0' WHERE paymentid='$paymentid'");
    }//}}}

    public static function deleteByCond($cond)
    {//{{{
        global $sql_tbl;

        $ids = func_query_column("SELECT paymentid FROM $sql_tbl[payment_methods] WHERE $cond");
        if (empty($ids)) {
            return false;
        }

        db_query("DELETE FROM $sql_tbl[payment_methods] WHERE paymentid IN ('" . implode("','", $ids) . "')");
        db_query("DELETE FROM $sql_tbl[pmethod_memberships] WHERE paymentid IN ('" . implode("','", $ids) . "')");
        db_query("UPDATE $sql_tbl[ccprocessors] SET paymentid='0' WHERE paymentid IN ('" . implode("','", $ids) . "')");
        return true;
    }//}}}
}

/**
 * This function joins order_id's and urlencodes 'em
 */
function func_get_urlencoded_orderids ($orderids)
{
    if (!is_array($orderids)) {
        return '';
    }

    return urlencode(join (",", $orderids));
}

function func_check_webinput($check_php = 1)
{
    global $config, $sql_tbl;

    static $pfiles = array (
        'ps_paypal_pro_hosted.php' => array(
            'ps_paypal_pro_hosted.php',
            'ps_paypal_ipn.php',
        ),
        'ps_paypal_pro.php' => array(
            'ps_paypal_pro.php',
            'ps_paypal_ipn.php',
        ),
        'ps_paypal.php' => array(
            'ps_paypal.php',
            'ps_paypal_ipn.php',
        ),
        'cc_klarna_pp.php' => 'cc_klarna.php',
        'cc_epdq.php' => 'cc_epdq_result.php',
        'cc_epdq_basic.php' => 'cc_epdq_basic_result.php',
        'cc_smartpag.php' => 'cc_smartpag_final.php',
        'cc_payzip.php' => 'cc_payzip_result.php',
        'cc_payflow_link.php' => 'cc_payflow_link_result.php',
        'cc_ogoneweb.php' => 'cc_ogoneweb_result.php',
        'cc_pswbill.php' => 'cc_pswbill_return.php',
        'cc_triple.php' => 'cc_triple_return.php',
        'cc_paybox.php' => 'cc_paybox_result.php',
        'cc_paypointft.php' => array(
            'cc_paypointft_response.php',
            'cc_paypointft.php'
        ),
        'cc_pp3.php' => array (
            'ebank_ok.php',
            'ebank_nok.php'
        ),
        'cc_pi.php' => 'cc_pi_result.php'
    );

    $allow_php = array(
    );
    $list = func_query_column("SELECT c.processor FROM $sql_tbl[ccprocessors] c, $sql_tbl[payment_methods] m WHERE m.active = 'Y' AND m.paymentid = c.paymentid AND (c.background <> 'Y' OR c.processor = 'ps_paypal_pro.php')");

    if ($list) {
        if (in_array('ps_paypal_pro.php', $list)) {
            $list[] = 'ps_paypal.php';
        }

        foreach($list as $file) {
            if (!empty($pfiles[$file])) {
                if (is_array($pfiles[$file]))
                    $allow_php = func_array_merge($allow_php, $pfiles[$file]);
                else
                    $allow_php[] = $pfiles[$file];
            }
            else {
                $allow_php[] = $file;
            }
        }
    }

    $ip = $_SERVER['REMOTE_ADDR'];
    $allow_ip = $config['Security']['allow_ips'];

    $not_found = true;
    if ($check_php && !empty($allow_php)) {
        for ($i = 0; $i < count($allow_php); $i++)
            $allow_php[$i] = preg_quote($allow_php[$i]);
        $script = $_SERVER['PHP_SELF'];
        $re_allow = "!(".implode("|",$allow_php).")$!S";
        $not_found = !preg_match($re_allow, $script);
    }

    if ($not_found) {
        x_log_flag('log_payment_processing_errors', 'PAYMENTS', "The script '".$_SERVER["PHP_SELF"]."' is not an entry point for a payment system!", true);
        header("Location: ../");
        die("Access denied");
    }

    if ($allow_ip && !defined('DISABLE_IP_CHECK')) {
        $not_found = true;
        $a = explode(",", $allow_ip);
        foreach ($a as $v) {
            list($aip, $amsk) = explode('/', trim($v));

            // Cannot use 0x100000000 instead 4294967296
            $amsk = 4294967296 - ($amsk ? pow(2,(32-$amsk)) : 1);

            if ((ip2long($ip) & $amsk) == ip2long($aip)) {
                $not_found = false;
                break;
            }
        }

        return ($not_found ? 'err' : 'pass');
    }

    return 'pass';
}

/**
 * Display payment page footer
 */
function func_payment_footer()
{
    global $xcart_dir, $smarty_skin_dir;

    if (defined('DISP_PAYMENT_FOOTER')) {
        return false;
    }

    $fn = $xcart_dir . $smarty_skin_dir . '/customer/main/payment_wait_end.tpl';

    $fp = @fopen($fn, 'r');

    if ($fp) {

        $data = fread($fp, func_filesize($fn));

        fclose($fp);

        $data = preg_replace("/\{\*.*\*\}/Us", '', $data);
        $data = preg_replace("/\{\/?literal\}/Us", '', $data);

        func_flush($data);
    }

    define('DISP_PAYMENT_FOOTER', true);
}

/**
 * Prepare smarty variables and display a form to submit
 * to the payment gateway
 *
 * @param string $url            URL to where the form will be submitted
 * @param array  $fields         Associative array as field_name => field_value
 * @param string $name           Name of the payment processor
 * @param string $method         Form submit method: get/post
 *
 * @return void
 * @see    ____func_see____
 */
function func_create_payment_form($url, $fields, $name, $method = 'post')
{
    global $smarty;

    $method = strtolower($method);
    if (!in_array($method, array('post', 'get'))) {
        $method = 'post';
    }

    // Assign Smarty vars and show form template

    $smarty->assign('request_url', $url);
    $smarty->assign('method', $method);
    $smarty->assign('fields', $fields);
    $smarty->assign('payment', $name);
    $smarty->assign('cc_current_year', intval(strftime('%Y')));

    $smarty->assign('autosubmit', true);

    func_flush(func_display('payments/payment_form.tpl', $smarty, false));
}

/**
 * Get valid IP
 */
function func_get_valid_ip($ip)
{
    return func_is_valid_ip($ip) ? $ip : '127.0.0.1';
}

/**
 * Check payment Activity
 */
function func_is_active_payment($php_script)
{
    global $sql_tbl;

    $cnt = func_query_first_cell("SELECT COUNT($sql_tbl[ccprocessors].processor) FROM $sql_tbl[ccprocessors], $sql_tbl[payment_methods] WHERE $sql_tbl[ccprocessors].processor = '".addslashes($php_script)."' AND $sql_tbl[ccprocessors].paymentid = $sql_tbl[payment_methods].paymentid AND $sql_tbl[payment_methods].active = 'Y'");
    return ($cnt > 0);

}

/**
 * Check if the device has small width
 */
function func_is_mobile()
{
    global $config;
    // the iphone6plus has 414 width. The paypal advanced iframe dialog has 426 width
    return !empty($config['Adaptives']['screen_x']) && $config['Adaptives']['screen_x'] <= 420;
}

/**
 * Force enable preauth
 */
function func_is_preauth_force_enabled($orderids)
{
    global $config;

    x_load('order');

    $frf = func_get_orders_fraud_risk_factor($orderids);
    if (!$frf)
        return false;

    $limit = intval($config['Anti_Fraud']['frf_limit_for_preauth']);

    return ($limit > 0 && $frf > $limit);
}

/**
 * Check pre-auth payment transaction with expired TTL
 */
function func_check_preauth_expiration()
{
    global $sql_tbl;

    $prev_event = func_get_event('payment_ttl');
    if ((XC_TIME - $prev_event) <= constant('SECONDS_PER_DAY')) {
        return func_get_langvar_by_name('txt_preauth_check_by_ttl_no_orders', array(), false, true);
    }
    func_set_event('payment_ttl');

    x_load('order');

    $orders = func_query("SELECT $sql_tbl[orders].orderid, $sql_tbl[orders].date, $sql_tbl[orders].status, $sql_tbl[ccprocessors].preauth_expire FROM $sql_tbl[order_extras] INNER JOIN $sql_tbl[orders] ON $sql_tbl[order_extras].orderid = $sql_tbl[orders].orderid AND $sql_tbl[orders].status = 'A' INNER JOIN $sql_tbl[ccprocessors] ON $sql_tbl[orders].paymentid = $sql_tbl[ccprocessors].paymentid AND $sql_tbl[ccprocessors].preauth_expire > 0 AND $sql_tbl[ccprocessors].has_preauth = 'Y' WHERE $sql_tbl[order_extras].khash = 'capture_status' AND $sql_tbl[order_extras].value = 'A'");

    if (empty($orders)) {
        return func_get_langvar_by_name('txt_preauth_decline_by_ttl_no_orders', array(), false, true);
    }

    $expired = array();
    foreach ($orders as $o) {
        if ($o['date'] + $o['preauth_expire'] < XC_TIME && func_order_is_voided(intval($o['orderid']))) {
            define('STATUS_CHANGE_REF', 4);
            func_change_order_status($o['orderid'], 'D');
            func_array2insert(
                'order_extras',
                array(
                    'orderid' => $o['orderid'],
                    'khash' => 'preauth_expired',
                    'value' => 'Y'
                ),
                true
            );
            $expired[] = $o['orderid'];
        }
    }

    if (count($expired) > 0) {
        return func_get_langvar_by_name('txt_preauth_decline_by_ttl', array('orders' => implode(", ", $expired)), false, true);
    }

    return func_get_langvar_by_name('txt_preauth_decline_by_ttl_no_orders', array(), false, true);
}

/**
 * Check pre-auth payment transaction TTL
 */
function func_check_preauth_expiration_ttl()
{
    global $sql_tbl, $mail_smarty, $config;

    x_load('order');

    $orders = func_query("SELECT $sql_tbl[orders].orderid, $sql_tbl[orders].date, $sql_tbl[orders].status, $sql_tbl[ccprocessors].preauth_expire FROM $sql_tbl[order_extras] INNER JOIN $sql_tbl[orders] ON $sql_tbl[order_extras].orderid = $sql_tbl[orders].orderid AND $sql_tbl[orders].status = 'A' INNER JOIN $sql_tbl[ccprocessors] ON $sql_tbl[orders].paymentid = $sql_tbl[ccprocessors].paymentid AND $sql_tbl[ccprocessors].preauth_expire > 0 AND $sql_tbl[ccprocessors].has_preauth = 'Y' LEFT JOIN $sql_tbl[order_extras] as oe2 ON oe2.orderid = $sql_tbl[order_extras].orderid AND oe2.khash = 'preath_expire_soon' WHERE $sql_tbl[order_extras].khash = 'capture_status' AND $sql_tbl[order_extras].value = 'A' AND oe2.value IS NULL");

    if (empty($orders) || $config['General']['preauth_expired_period_warning'] <= 0) {
        return func_get_langvar_by_name('txt_preauth_check_by_ttl_no_orders', array(), false, true);
    }

    $expired = array();
    foreach ($orders as $o) {
        if (($o['date'] + $o['preauth_expire'] - ($config['General']['preauth_expired_period_warning'] * 86400) < XC_TIME) && func_order_is_authorized(intval($o['orderid']))) {
            $expired[] = $o['orderid'];
            func_array2insert(
                'order_extras',
                array(
                    'orderid' => $o['orderid'],
                    'khash' => 'preath_expire_soon',
                    'value' => 'Y'
                ),
                true
            );
        }
    }

    if (count($expired) > 0) {
        $mail_smarty->assign('orderids', implode(", ", $expired));
        func_send_mail(
            $config['Company']['orders_department'],
            'mail/order_preauth_expire_subj.tpl',
            'mail/order_preauth_expire.tpl',
            $config['Company']['site_administrator'],
            false
        );
        return func_get_langvar_by_name('txt_preauth_check_by_ttl', array('orders' => implode(", ", $expired)), false, true);
    }

    return func_get_langvar_by_name('txt_preauth_check_by_ttl_no_orders', array(), false, true);
}

/**
 * Get payment module parameters
 */
function func_get_pm_params($payment_name, $skip_extra_params = false) {

    global $sql_tbl;

    if (is_numeric($payment_name)) {
        $data = func_query_first("SELECT * FROM $sql_tbl[ccprocessors] WHERE paymentid = '$payment_name'");
    } else {
        $data = func_query_first("SELECT * FROM $sql_tbl[ccprocessors] WHERE processor = '$payment_name'");
    }

    if (!empty($data) && !$skip_extra_params) {
        $params = func_query_hash("SELECT param, value FROM $sql_tbl[ccprocessor_params] WHERE processor = '$data[processor]'", 'param', false, true);
        if (!empty($params)) {
            $data['params'] = $params;
        }
    }

    return $data;
}

/**
 * Include payment module functions repository
 */
function func_pm_load($payment_name)
{
    global $xcart_dir;
    static $cache = array();

    if (!is_string($payment_name) || zerolen($payment_name)) {
        return false;
    }

    $payment_name = preg_replace('/\.php$/Ss', '', $payment_name);

    if (isset($cache[$payment_name])) {
        return true;
    }

    $path = $xcart_dir . '/include/payment/func.' . $payment_name . '.php';

    if (!file_exists($path) || !is_readable($path)) {
        return false;
    }

    require_once($path);
    $cache[$payment_name] = true;

    return true;
}

/**
 * Get function name for Capture transaction
 */
function func_payment_get_capture_func($paymentid, $orderid = 0)
{
    global $sql_tbl, $active_modules;

    $processor_data = func_query_first("SELECT processor_file, payment_script FROM $sql_tbl[payment_methods] WHERE paymentid = '" . $paymentid . "'" );
    $processor_file = $processor_data['processor_file'];
    $payment_script = $processor_data['payment_script'];

    if (strpos($processor_file, 'ps_paypal') === 0) {
        x_load('paypal');
    }

    if ($processor_file == 'ps_paypal_pro.php') {
        $ids = func_query_column("SELECT paymentid FROM $sql_tbl[payment_methods] WHERE processor_file = '$processor_file'");
        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid IN ('" . implode("','", $ids) . "')");

        if (!empty($orderid)) {
            $paypal = func_paypal_get_order_data($orderid);
        }

    } elseif ($processor_file == 'ps_paypal_payflowlink.php') {
        $processor = 'ps_paypal_advanced.php';
        
    } elseif ($processor_file == 'cc_xpc.php' || $payment_script == 'payment_xpc_recharge.php') {

        if (empty($active_modules['XPayments_Connector'])) {
            return false;
        }

        func_xpay_func_load();

        if ($payment_script == 'payment_xpc_recharge.php') {
            $paymentid = xpc_get_orig_paymentid_for_recharge($orderid);
        }

        return xpc_can_capture($paymentid);

    } else {
        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid = '" . $paymentid . "'");
    }

    if (!$processor) {
        return false;
    }

    $payment_name = preg_replace("/\.php/Ss", '', $processor);

    $func_name = 'func_' . $payment_name .'_do_capture';

    func_pm_load($payment_name);

    return function_exists($func_name) ? $func_name : false;
}

/**
 * Get function name for Void transaction
 */
function func_payment_get_void_func($paymentid, $orderid = 0)
{
    global $sql_tbl, $active_modules;

    $processor_data = func_query_first("SELECT processor_file, payment_script FROM $sql_tbl[payment_methods] WHERE paymentid = '" . $paymentid . "'" );
    $processor_file = $processor_data['processor_file'];
    $payment_script = $processor_data['payment_script'];

    if (strpos($processor_file, 'ps_paypal') !== false) {
        x_load('paypal');
    }

    if ($processor_file == 'ps_paypal_pro.php') {

        $ids = func_query_column("SELECT paymentid FROM $sql_tbl[payment_methods] WHERE processor_file = '$processor_file'");
        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid IN ('" . implode("','", $ids) . "')");
        if (!empty($orderid)) {
            $paypal = func_paypal_get_order_data($orderid);
        }

    } elseif ($processor_file == 'ps_paypal_payflowlink.php') {
        $processor = 'ps_paypal_advanced.php';

    } elseif ($processor_file == 'cc_xpc.php' || $payment_script == 'payment_xpc_recharge.php') {

        if (empty($active_modules['XPayments_Connector'])) {
            return false;
        }

        func_xpay_func_load();

        if ($payment_script == 'payment_xpc_recharge.php') {
            $paymentid = xpc_get_orig_paymentid_for_recharge($orderid);
        }

        return xpc_can_void($paymentid);

    } else {
        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid = '" . $paymentid . "'");
    }

    if (!$processor) {
        return false;
    }

    $payment_name = preg_replace("/\.php/Ss", '', $processor);

    $func_name = 'func_' . $payment_name .'_do_void';

    func_pm_load($payment_name);

    return function_exists($func_name) ? $func_name : false;
}

/**
 * Get function name for Refund transaction
 */
function func_payment_get_refund_func($paymentid, $orderid = 0)
{
    global $sql_tbl, $active_modules;

    $processor_data = func_query_first("SELECT processor_file, payment_script FROM $sql_tbl[payment_methods] WHERE paymentid = '" . $paymentid . "'" );
    $processor_file = $processor_data['processor_file'];
    $payment_script = $processor_data['payment_script'];

    $processor = false;
    if ($processor_file == 'ps_paypal_pro.php') {

        x_load('paypal');

        if (!empty($orderid)) {
            $paypal = func_paypal_get_order_data($orderid);
        }

        if (!empty($paypal) && $paypal['api'] == 'EC' && $paypal['method'] == 'UK') {
            // US refunds are handled by other functions
            $processor = 'ps_paypal_pro.php';

        }

    } elseif ($processor_file == 'ps_paypal_payflowlink.php') {

        $processor = 'ps_paypal_advanced.php';

    } elseif ($processor_file == 'cc_xpc.php' || $payment_script == 'payment_xpc_recharge.php') {

        if (empty($active_modules['XPayments_Connector'])) {
            return false;
        }

        func_xpay_func_load();

        if ($payment_script == 'payment_xpc_recharge.php') {
            $paymentid = xpc_get_orig_paymentid_for_recharge($orderid);
        }

        return xpc_can_refund($paymentid);

    } elseif (!empty($active_modules['Amazon_Payments_Advanced'])) {

        if (!func_amazon_pa_is_configured()) {
            return false;
        }

        $processor = 'amazon_pa';

    } else {

        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid = '" . $paymentid . "'");
    }

    if (!$processor) {
        return false;
    }

    $payment_name = preg_replace("/\.php/Ss", '', $processor);

    $func_name = 'func_' . $payment_name .'_do_refund';

    func_pm_load($payment_name);

    return function_exists($func_name) ? $func_name : false;
}

/**
 * Get function name for Get refund transaction mode
 */
function func_payment_get_refund_mode($paymentid, $orderid)
{ //{{{
    global $sql_tbl, $active_modules;

    static $res = array();
    $md5_args = $paymentid . '|' . $orderid;
    if (isset($res[$md5_args])) {
        return $res[$md5_args];
    }

    if (empty($paymentid)) {
        // For orders placed via AMazon_Checkout or PIlibaba checkout
        return false;
    }

    $processor_data = func_query_first("SELECT processor_file, payment_script FROM $sql_tbl[payment_methods] WHERE paymentid = '" . $paymentid . "'" );
    $processor_file = $processor_data['processor_file'];
    $payment_script = $processor_data['payment_script'];
    
    $return = false;
    $func_name = false;
    if ($processor_file == 'ps_paypal_pro.php') {

        x_load('paypal');
        $paypal = func_paypal_get_order_data($orderid);

        if (!empty($paypal) && $paypal['api'] == 'EC' && $paypal['method'] == 'UK') {
            $func_name = 'func_paypal_express_payflow_refund_mode';
        }

    } elseif ($processor_file == 'ps_paypal_payflowlink.php' || $processor_file == 'ps_paypal_advanced.php') {
        $processor = 'ps_paypal_advanced.php';
        $payment_name = preg_replace("/\.php/Ss", '', $processor);
        $func_name = 'func_' . $payment_name .'_get_refund_mode';
        func_pm_load($payment_name);

    } elseif ($processor_file == 'cc_xpc.php' || $payment_script == 'payment_xpc_recharge.php') {

        if (!empty($active_modules['XPayments_Connector'])) {
            func_xpay_func_load();

            if ($payment_script == 'payment_xpc_recharge.php') {
                $paymentid = xpc_get_orig_paymentid_for_recharge($orderid);
            }

            $func_name = 'xpc_get_refund_mode';
        }

    } else {
        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid = '" . $paymentid . "'");
        $payment_name = preg_replace("/\.php/Ss", '', $processor);
        $func_name = 'func_' . $payment_name .'_get_refund_mode';
        func_pm_load($payment_name);
    }

    if ($func_name && function_exists($func_name)) {
        $return = $func_name($paymentid, $orderid);
    }

    $res[$md5_args] = $return;
    return $return;
}//}}}

/**
 * Get function name for Accept transaction
 */
function func_payment_get_accept_func($paymentid, $orderid = 0)
{
    global $sql_tbl, $active_modules;

    $processor_data = func_query_first("SELECT processor_file, payment_script FROM $sql_tbl[payment_methods] WHERE paymentid = '" . $paymentid . "'" );
    $processor_file = $processor_data['processor_file'];
    $payment_script = $processor_data['payment_script'];

    if (strpos($processor_file, 'ps_paypal') !== false) {
        x_load('paypal');
    }

    if ($processor_file == 'ps_paypal_pro.php') {
        $ids = func_query_column("SELECT paymentid FROM $sql_tbl[payment_methods] WHERE processor_file = '$processor_file'");
        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid IN ('" . implode("','", $ids) . "')");

        if (!empty($orderid)) {
            $paypal = func_paypal_get_order_data($orderid);
        }

    } elseif ($processor_file == 'cc_xpc.php' || $payment_script == 'payment_xpc_recharge.php') {

        if (empty($active_modules['XPayments_Connector'])) {
            return false;
        }

        func_xpay_func_load();

        if ($payment_script == 'payment_xpc_recharge.php') {
            $paymentid = xpc_get_orig_paymentid_for_recharge($orderid);
        }

        return xpc_can_accept($paymentid);

    } else {
        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid = '" . $paymentid . "'");
    }

    if (!$processor) {
        return false;
    }

    $payment_name = preg_replace("/\.php/Ss", '', $processor);

    $func_name = 'func_' . $payment_name .'_do_accept';

    func_pm_load($payment_name);

    return function_exists($func_name) ? $func_name : false;
}

/**
 * Get function name for Decline transaction
 */
function func_payment_get_decline_func($paymentid, $orderid = 0)
{
    global $sql_tbl, $active_modules;

    $processor_data = func_query_first("SELECT processor_file, payment_script FROM $sql_tbl[payment_methods] WHERE paymentid = '" . $paymentid . "'" );
    $processor_file = $processor_data['processor_file'];
    $payment_script = $processor_data['payment_script'];

    if (strpos($processor_file, 'ps_paypal') === 0) {
        x_load('paypal');
    }

    if ($processor_file == 'ps_paypal_pro.php') {
        $ids = func_query_column("SELECT paymentid FROM $sql_tbl[payment_methods] WHERE processor_file = '$processor_file'");
        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid IN ('" . implode("','", $ids) . "')");

        if (!empty($orderid)) {
            $paypal = func_paypal_get_order_data($orderid);
        }

    } elseif ($processor_file == 'cc_xpc.php' || $payment_script == 'payment_xpc_recharge.php') {

        if (empty($active_modules['XPayments_Connector'])) {
            return false;
        }

        func_xpay_func_load();

        if ($payment_script == 'payment_xpc_recharge.php') {
            $paymentid = xpc_get_orig_paymentid_for_recharge($orderid);
        }

        return xpc_can_decline($paymentid);

    } else {
        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid = '" . $paymentid . "'");
    }

    if (!$processor) {
        return false;
    }

    $payment_name = preg_replace("/\.php/Ss", '', $processor);

    $func_name = 'func_' . $payment_name .'_do_decline';

    func_pm_load($payment_name);

    return function_exists($func_name) ? $func_name : false;
}

/**
 * Get function name for GetInfo transaction
 */
function func_payment_get_get_info_func($paymentid, $orderid = 0)
{
    global $sql_tbl, $active_modules;

    $processor_data = func_query_first("SELECT processor_file, payment_script FROM $sql_tbl[payment_methods] WHERE paymentid = '" . $paymentid . "'" );
    $processor_file = !empty($processor_data['processor_file']) ? $processor_data['processor_file'] : '';
    $payment_script = !empty($processor_data['payment_script']) ? $processor_data['payment_script'] : '';

    if (strpos($processor_file, 'ps_paypal') === 0) {
        x_load('paypal');
    }

    if ($processor_file == 'ps_paypal_pro.php') {
        $ids = func_query_column("SELECT paymentid FROM $sql_tbl[payment_methods] WHERE processor_file = '$processor_file'");
        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid IN ('" . implode("','", $ids) . "')");

        if (!empty($orderid)) {
            $paypal = func_paypal_get_order_data($orderid);
        }

    } elseif ($processor_file == 'cc_xpc.php' || $payment_script == 'payment_xpc_recharge.php') {

        if (empty($active_modules['XPayments_Connector'])) {
            return false;
        }

        func_xpay_func_load();

        // Should be always true. Anyway...
        if ($payment_script == 'payment_xpc_recharge.php') {
            $paymentid = xpc_get_orig_paymentid_for_recharge($orderid);
        }

        return xpc_can_get_info($paymentid);

    } else {
        $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid = '" . $paymentid . "'");
    }

    if (!$processor) {
        return false;
    }

    $payment_name = preg_replace("/\.php/Ss", '', $processor);

    $func_name = 'func_' . $payment_name .'_do_get_info';

    func_pm_load($payment_name);

    return function_exists($func_name) ? $func_name : false;
}

/**
 * Get service message for payment methods with Authorize and without Capture/Void
 */
function func_payment_get_non_capture_message($paymentid)
{
    global $sql_tbl;

    $processor = func_query_first_cell("SELECT processor FROM $sql_tbl[ccprocessors] WHERE paymentid = '" . $paymentid . "'");
    if (!$processor) {
        return false;
    }

    $lbl_name = 'lbl_' . preg_replace("/\.php/Ss", '', $processor).'_non_capture_message';

    return func_get_langvar_by_name($lbl_name, array(), false, true);
}

/**
 * Do Capture transaction
 */
function func_payment_do_capture($orderid)
{
    $order = func_order_data($orderid);
    if (!$order) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_order_not_found')
        );
    }

    $func_name = func_payment_get_capture_func($order['order']['paymentid'], $orderid);
    if (!$func_name) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_payment_module_internal_error')
        );
    }

    x_load('order');

    $order['order']['total'] = $order['order']['capture_full_total'];
    if (!func_check_capture_limit(intval($orderid))) {
        $order['order']['total'] = $order['order']['init_total'];
        $override_total = $order['order']['init_total'];
    }

    list($ret, $err_msg, $extra) = $func_name($order);

    func_store_advinfo($orderid, $err_msg);

    if ($ret === true || (is_int($ret) && $ret > 0)) {
        x_load('order');
        $orderids = func_get_order_ids($orderid);

        $is_order_still_pending_after_capture = !empty($extra['is_pending']);
        func_order_process_capture($orderids, NULL, $is_order_still_pending_after_capture);

        func_array2insert(
            'order_extras',
            array(
                'orderid' => $orderid,
                'khash' => 'captured_total',
                'value' => $order['order']['total']
            ),
            true
        );

        if ($ret === true) {
            $err_msg = '';
        }

    }

    if (($ret === true || (is_int($ret) && $ret > 0)) && !$err_msg) {

        if (is_int($ret)) {
            if ($ret & X_PAYMENT_TRANS_ALREADY_CAPTURED) {
                return array(
                    'content' => func_get_langvar_by_name('lbl_payment_trans_already_captured')
                );
            }
        }

        if (isset($override_total)) {
            return array(
                'content' => func_get_langvar_by_name('lbl_payment_capture_successfully_differ', array('captured_total' => $override_total))
            );
        }

        return array(
            'content' => func_get_langvar_by_name('lbl_payment_capture_successfully')
        );
    }

    if ($ret === 'Q') {
        x_load('order');
        $orderids = func_get_order_ids($orderid);

        define('STATUS_CHANGE_REF', 5);
        func_change_order_status($orderids, 'Q');
    }

    return array(
        'type' => 'E',
        'content' => $err_msg ? func_get_langvar_by_name('lbl_payment_capture_error', array('error_message' => $err_msg)) : func_get_langvar_by_name('lbl_payment_module_internal_error')
    );
}

/**
 * Do Void transaction
 */
function func_payment_do_void($orderid, $process_mode = 0)
{
    $order = func_order_data($orderid);
    if (!$order) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_order_not_found')
        );
    }

    $func_name = func_payment_get_void_func($order['order']['paymentid'], $orderid);
    if (!$func_name) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_payment_module_internal_error')
        );
    }

    list($ret, $err_msg, $extra) = $func_name($order);

    func_store_advinfo($orderid, $err_msg);

    if ($ret === true || (is_int($ret) && $ret > 0)) {
        x_load('order');
        $orderids = func_get_order_ids($orderid);

        func_order_process_void($orderids, $process_mode);

        if ($ret === true) {
            $err_msg = '';
        }

    }

    if (($ret === true || (is_int($ret) && $ret > 0)) && !$err_msg) {
        if (is_int($ret)) {
            if ($ret & X_PAYMENT_TRANS_ALREADY_VOIDED) {
                return array(
                    'content' => func_get_langvar_by_name('lbl_payment_trans_already_declined')
                );
            }
        }

        return array(
            'content' => func_get_langvar_by_name('lbl_payment_void_successfully')
        );
    }

    return array(
        'type' => 'E',
        'content' => $err_msg ? func_get_langvar_by_name('lbl_payment_void_error', array('error_message' => $err_msg)) : func_get_langvar_by_name('lbl_payment_module_internal_error')
    );
}

/**
 * Do Refund transaction
 */
function func_payment_do_refund($orderid, $total = null)
{
    global $active_modules;

    $order = func_order_data($orderid);
    if (!$order) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_order_not_found')
        );
    }

    if (!in_array($order['order']['charge_info']['refund_mode'], array('Y', 'P'))) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_payment_module_internal_error')
        );
    }

    $func_name = func_payment_get_refund_func($order['order']['paymentid'], $orderid);

    if (!$func_name) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_payment_module_internal_error')
        );
    }

    if ($order['order']['charge_info']['refund_avail'] <= 0) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('txt_order_is_totally_refunded')
        );
    }

    if (!is_null($total)) {
        $total = doubleval($total);
        if ($order['order']['charge_info']['refund_mode'] == 'Y') {
            return array(
                'type' => 'E',
                'content' => func_get_langvar_by_name('txt_payment_module_can_only_full_refund')
            );

        } elseif ($total > $order['order']['charge_info']['refund_avail']) {
            return array(
                'type' => 'E',
                'content' => func_get_langvar_by_name('txt_refund_amount_bigger_charged_total')
            );

        } elseif ($total < 0) {
            return array(
                'type' => 'E',
                'content' => func_get_langvar_by_name('txt_refund_amount_has_small_value')
            );
        }
    }

    list($ret, $err_msg, $extra) = $func_name($order, $total);

    func_store_advinfo($orderid, $err_msg);

    if ($ret === true || (is_int($ret) && $ret > 0)) {
        x_load('order');
        $orderids = func_get_order_ids($orderid);

        $total = is_null($total) ? $order['order']['charge_info']['refund_avail'] : $total;

        func_order_process_refund($orderids, $total);

        $err_msg = '';
    }

    if (($ret === true || (is_int($ret) && $ret > 0)) && !$err_msg) {

        if (is_int($ret)) {
            if ($ret & X_PAYMENT_TRANS_ALREADY_REFUNDED) {
                return array(
                    'content' => func_get_langvar_by_name('lbl_payment_trans_already_refunded')
                );
            }
        }

        if (!empty($active_modules['XPayments_Connector'])) {
            // Get actual refund totals from X-Payments
            func_payment_do_get_info($orderid);
        }

        return array(
            'content' => func_get_langvar_by_name('lbl_payment_refund_successfully')
        );
    }

    if ($ret === 'Q') {
        x_load('order');
        $orderids = func_get_order_ids($orderid);

        define('STATUS_CHANGE_REF', 11);
        func_change_order_status($orderids, 'Q');
    }

    return array(
        'type' => 'E',
        'content' => $err_msg ? func_get_langvar_by_name('lbl_payment_refund_error', array('error_message' => $err_msg), false, true) : func_get_langvar_by_name('lbl_payment_module_internal_error')
    );
}

/**
 * Do Accept transaction
 */
function func_payment_do_accept($orderid)
{
    $order = func_order_data($orderid);
    if (!$order) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_order_not_found')
        );
    }

    $func_name = func_payment_get_accept_func($order['order']['paymentid'], $orderid);
    if (!$func_name) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_payment_module_internal_error')
        );
    }

    list($ret, $err_msg, $extra) = $func_name($order);

    func_store_advinfo($orderid, $err_msg);

    if ($ret === true || (is_int($ret) && $ret > 0)) {
        x_load('order');
        $orderids = func_get_order_ids($orderid);

        func_order_process_accept($orderids);

        if (is_int($ret)) {
            if ($ret & X_PAYMENT_TRANS_ALREADY_ACCEPTED) {
                return array(
                    'content' => func_get_langvar_by_name('lbl_payment_trans_already_accepted')
                );
            }
        }

        return array(
            'content' => func_get_langvar_by_name('lbl_payment_accept_successfully')
        );
    }

    return array(
        'type' => 'E',
        'content' => $err_msg ? func_get_langvar_by_name('lbl_payment_accept_error', array('error_message' => $err_msg)) : func_get_langvar_by_name('lbl_payment_module_internal_error')
    );
}

/**
 * Do Decline transaction
 */
function func_payment_do_decline($orderid)
{
    $order = func_order_data($orderid);
    if (!$order) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_order_not_found')
        );
    }

    $func_name = func_payment_get_decline_func($order['order']['paymentid'], $orderid);
    if (!$func_name) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_payment_module_internal_error')
        );
    }

    list($ret, $err_msg, $extra) = $func_name($order);

    func_store_advinfo($orderid, $err_msg);

    if ($ret === true || (is_int($ret) && $ret > 0)) {
        x_load('order');
        $orderids = func_get_order_ids($orderid);

        func_order_process_decline($orderids);

        if (is_int($ret)) {
            if ($ret & X_PAYMENT_TRANS_ALREADY_DECLINE) {
                return array(
                    'content' => func_get_langvar_by_name('lbl_payment_trans_already_declined')
                );
            }
        }

        return array(
            'content' => func_get_langvar_by_name('lbl_payment_decline_successfully')
        );
    }

    return array(
        'type' => 'E',
        'content' => $err_msg ? func_get_langvar_by_name('lbl_payment_decline_error', array('error_message' => $err_msg)) : func_get_langvar_by_name('lbl_payment_module_internal_error')
    );
}

/**
 * Do GetInfo transaction
 */
function func_payment_do_get_info($orderid)
{
    $order = func_order_data($orderid);
    if (!$order) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_order_not_found')
        );
    }

    $func_name = func_payment_get_get_info_func($order['order']['paymentid'], $orderid);
    if (!$func_name) {
        return array(
            'type' => 'E',
            'content' => func_get_langvar_by_name('lbl_payment_module_internal_error')
        );
    }

    list($ret, $err_msg, $extra, $data) = $func_name($order);

    func_store_advinfo($orderid, $err_msg);

    if ($ret) {
        x_load('order');
        $orderids = func_get_order_ids($orderid);

        func_order_process_get_info($orderids, $data);

        return array(
            'content' => func_get_langvar_by_name('lbl_payment_get_info_successfully')
        );
    }

    return array(
        'type' => 'E',
        'content' => $err_msg ? func_get_langvar_by_name('lbl_payment_get_info_error', array('error_message' => $err_msg)) : func_get_langvar_by_name('lbl_payment_module_internal_error')
    );
}

/**
 * Get capture total limits by processor name
 */
function func_get_capture_limits($processor)
{
    $module_params = func_get_pm_params($processor);
    if (!$module_params) {
        return array(false, false);
    }

    foreach (array('capture_min_limit', 'capture_max_limit') as $fn) {
        if (preg_match('/^[\d\.]+%$/', $module_params[$fn])) {
            $module_params[$fn] = doubleval(substr($module_params[$fn], 0, -1)) . '%';

        } elseif (preg_match('/^[\d\.]+$/', $module_params[$fn])) {
            $module_params[$fn] = doubleval($module_params[$fn]);

        } else {
            $module_params[$fn] = '0%';
        }
    }

    return array($module_params['capture_min_limit'], $module_params['capture_max_limit']);
}

/**
 * Check capture transaction by limits
 */
function func_check_capture_limit($orderid)
{
    global $sql_tbl;

    if (!is_int($orderid) || $orderid < 1) {
        return false;
    }

    $order = func_query_first("SELECT paymentid, total, init_total FROM $sql_tbl[orders] WHERE orderid = '" . $orderid . "'");
    if (!$order || !$order['paymentid']) {
        return false;
    }

    $processor = func_query_first_cell("SELECT processor_file FROM $sql_tbl[payment_methods] WHERE paymentid = '" . $order['paymentid'] . "'");
    if (!$processor) {
        return false;
    }

    if ($order['total'] <= 0) {
        return false;
    }

    if ($order['init_total'] == $order['total']) {
        return true;
    }

    // Check by processor function
    func_pm_load($processor);

    $function_name = 'func_' . preg_replace("/\.php/Ss", "", $processor) . '_check_capture_limit';
    if (function_exists($function_name)) {
        return $function_name($order['init_total'], $order['total']);
    }

    // Check by porcessor limits
    list($min, $max) = func_get_capture_limits($processor);
    if ($min === false) {
        return false;
    }

    if (preg_match('/%$/S', $min)) {
        $min = $order['init_total'] * substr($min, 0, -1) / 100;
    } else {
        $min = $order['init_total'] - $min;
    }

    if (preg_match('/%$/S', $max)) {
        $max = $order['init_total'] * substr($max, 0, -1) / 100 + $order['init_total'];
    } else {
        $max = $order['init_total'] + $max;
    }

    return $order['total'] >= round($min, 2) && $order['total'] <= round($max, 2);
}

/**
 * Log payment processing error
 */
function func_pp_error_log($msg)
{
    global $login;

    return x_log_flag(
        'log_payment_processing_errors',
        'PAYMENTS',
        "Payment processing failure.\nLogin: " . $login . "\nIP: " . $_SERVER['REMOTE_ADDR'] . "\n----\n" . $msg,
        true
    );
}

/**
 * Get payment module currencies list
 */
function func_pm_get_currencies($processor)
{
    global $sql_tbl;

    $processor = basename($processor);
    if (!func_pm_load($processor))
        return array();

    $payment_name = preg_replace("/\.php/Ss", '', $processor);
    $func_name = 'func_' . $payment_name . '_get_currencies';
    if (function_exists($func_name)) {
        return $func_name(func_query("SELECT * FROM $sql_tbl[currencies]"));
    }

    return array();
}

function func_is_pmethods_list_empty($payment_methods)
{
    $is_empty = true;
    foreach ($payment_methods as $pm) {
        if ($pm['active'] == 'Y' || $pm['processor']) {
            $is_empty = false;
            break;
        }
    }

    return $is_empty;
}

function func_is_complex_processor($processor)
{
    return in_array(
        $processor,
        array(
            'cc_2conew.php', 'cc_worldpay.php', 'cc_anz.php',
            'cc_goem_pf.php', 'cc_ideal_rb_prof.php', 'cc_ideal_basic.php', 'cc_ideala.php',
            'cc_hsbc.php', 'cc_isecure.php', 'cc_mbookers.php',
            'cc_mbookers_wlt.php', 'cc_multicard.php', 'cc_netbanx.php', 'ps_nochex.php',
            'cc_ogoneweb.php', 'cc_pnpss.php', 'cc_pp3.php', 'cc_psigate.php',
            'cc_securetrading.php', 'cc_paypointft.php', 'cc_securetrading.php',
            'cc_csrc_sa_wm.php', 'cc_nab_transact.php'
        )
    );
}

function func_is_selected_gateway($processor)
{
    return in_array(
        $processor,
        array(
        )
    );
}

function func_decode_processor_code($processor)
{
    $pm_id = false;

    if (preg_match("/cc_xpc\.php_([0-9]+)/", $processor, $match)) {
        $pm_id = intval($match[1]);
        $processor = 'cc_xpc.php';
    }

    return array($processor, $pm_id);
}

function func_get_processor_by_id($processor)
{
    global $sql_tbl;

    list($processor, $pm_id) = func_decode_processor_code($processor);
    $processor_query = "processor = '" . $processor . "'";
    if ($pm_id) {
        $processor_query .= " AND param01 = '$pm_id'";
    }

    return func_query_first("SELECT * FROM $sql_tbl[ccprocessors] WHERE " . $processor_query);
}

/**
 * Register payment processor
 *
 * @global type $sql_tbl
 * @global type $recent_payment_methods
 *
 * @param string $processor
 * @param integer $orderby
 *
 * @return integer paymentid
 */
function func_add_processor($processor, $orderby = 999)
{ // {{{
    global $sql_tbl, $recent_payment_methods;

    x_session_register('recent_payment_methods');

    $tmp = func_get_processor_by_id($processor);

    if ($tmp['paymentid']) {
        return $tmp['paymentid'];
    }

    $cc_processor = $tmp['module_name'];
    $processor = $tmp['processor'];
    $background = $tmp['background'];

    if (!zerolen($tmp['c_template'])) {
        $template = $tmp['c_template'];

    } else {
        $type_2_template = array (
            'C' => 'customer/main/payment_cc.tpl',
            'D' => 'customer/main/payment_dd.tpl',
            'H' => 'customer/main/payment_chk.tpl',
            'X' => 'customer/main/payment_xpc.tpl',
        );
        $template = get_value($type_2_template, $tmp['type'], 'customer/main/payment_offline.tpl');
    }

    if ($processor == 'ps_paypal.php') {

        x_load('paypal');

        $paymentid = func_paypal_add_payment_methods($orderby);  

        $name = 'PayPal';

    } else {

        $insert_params = array (
            'payment_method' => $cc_processor,
            'payment_script' => 'payment_cc.php',
            'payment_template' => $template,
            'active' => 'N',
            'orderby' => $orderby,
            'processor_file' => $processor
        );

        $paymentid = XCPayment::addPayment($insert_params);

        $processor_query = "processor = '" . $processor . "'";
        if ($processor == 'cc_xpc.php') {
            $processor_query .= " AND param01 = '" . $tmp['param01'] . "'";
        }

        func_array2update('ccprocessors', array('paymentid' => $paymentid), $processor_query);

        $name = func_query_first_cell("SELECT payment_method FROM $sql_tbl[payment_methods] WHERE paymentid='$paymentid'");

    }

    $recent_payment_methods[$processor.$paymentid] = array(
        'script' => $processor,
        'name' => $name,
        'paymentid' => $paymentid,
        'background' => $background
    );

    return $paymentid;
} // }}}

/**
 * Unregister payment processor
 *
 * @global type $recent_payment_methods
 *
 * @param string $processor
 */
function func_remove_processor($processor)
{ // {{{
    global $recent_payment_methods;

    // Get session recent methods
    x_session_register('recent_payment_methods', array());

    // Unregister processor
    XCPayment::deleteByCond("processor_file='" . $processor . "'");

    // Update recent payments array
    if (!empty($recent_payment_methods)) {
        // Iterate through the list
        foreach ($recent_payment_methods as $k => $v) {
            // check if processor registered in the list
            if ($v['script'] == $processor) {
                // remove it from the list
                unset($recent_payment_methods[$k]);
            }
        }
    }

} // }}}

/**
 * Write debug data to log
 *
 * @param string $prefix    log filename prefix
 * @param string $action    action
 * @param array  $data      debug data
 *
 * @return void
 * @access public
 * @see    ____func_see____
 */
function func_pp_debug_log($prefix = 'payment', $action = 'I', $data = array())
{ // {{{

    if (empty($data)) {
        return;
    }

    switch ($action) {
        case 'I':
            $log_msg = 'Payment request:';
            break;
        case 'C':
            $log_msg = 'Callback received:';
            break;
        case 'R':
            $log_msg = 'Response received:';
            break;
        case 'F':
            $log_msg = 'Inline frame params:';
            break;
        case 'B':
            $log_msg = 'User returned back to store:';
            break;
        default:
            $log_msg = "Request data($action):";
    }

    $log_msg .= "\n" . print_r($data, TRUE);

    x_log_add($prefix, $log_msg);
} // }}}

function func_check_payment_country($processor, $country_code) {
    global $sql_tbl;

    if ($processor == 'ps_paypal.php') {
        $show_paypal_methods = func_query_hash("SELECT payment_type, country_code FROM $sql_tbl[payment_countries] WHERE processor = '$processor'", 'payment_type', TRUE, TRUE);

        if ($show_paypal_methods) {
            foreach ($show_paypal_methods as $k => $v) {
                if ($country_code == 'none' || empty($v[0]) || in_array($country_code, $v)) {
                    $show_methods[$k] = 'Y';
                } else {
                    $show_methods[$k] = 'N';
                }
            }
        }
    }

    return $show_methods;
}

function func_get_payment_countries($add_xp_methods = false) {
    global $sql_tbl, $shop_language;

    $return = array();

    $paypal_cond = "AND pc.processor NOT LIKE 'ps_paypal%'";
    $return['processors'] = func_query_hash("(SELECT pc.processor, pc.country_code FROM $sql_tbl[payment_countries] pc WHERE pc.country_code <> '' $paypal_cond) UNION ALL (SELECT pc.processor, c.code AS country_code FROM $sql_tbl[payment_countries] pc INNER JOIN $sql_tbl[countries] c USING(region) WHERE pc.region <> '' $paypal_cond) ",'processor', true, true);

    $return['countries'] = array();

    if ($add_xp_methods) {
        $xp_methods = func_get_xp_processors('in_hash');
        foreach ($xp_methods as $xp_class => $xp_method) {
            if (!empty($xp_method['countries'])) {
                $return['processors'][$xp_class] = $xp_method['countries'];
            }
        }
    }

    $country_names = func_query_hash("SELECT name, value FROM $sql_tbl[languages] WHERE name LIKE 'country_%' AND code = '$shop_language'", 'name', false, true);
    foreach ($return['processors'] as $processor => $proc_countries) {
        foreach ($return['processors'][$processor] as $country) {
            if (!array_key_exists($country, $return['countries'])) {
                $return['countries'][$country] = isset($country_names['country_' . $country]) ? $country_names['country_' . $country] : $country;//func_get_country($country);
            }
        }
    }

    asort($return['countries']);

    return $return;

}

function func_get_3letters_country_code($two_letters_code) {
    global $sql_tbl;

    $three_letters_code = func_query_first_cell("SELECT code_A3 FROM $sql_tbl[countries] WHERE code = '$two_letters_code'", TRUE);

    return $three_letters_code;
}

function func_populate_payment_tabs() {
    global $smarty, $active_modules, $xcart_dir;

    $payment_methods_tabs = array();

    $payment_methods_tabs[] = array(
        'title' => func_get_langvar_by_name('lbl_payment_methods'),
        'tpl' => 'admin/main/payment_methods_tab.tpl',
        'anchor' => 'payment-methods',
    );

    $payment_methods_tabs[] = array(
        'title' => func_get_langvar_by_name('lbl_payment_gateways'),
        'tpl' => 'admin/main/payment_gateways_tab.tpl',
        'anchor' => 'payment-gateways',
    );

    $payment_methods_tabs[] = array(
        'title' => func_get_langvar_by_name('lbl_quick_info'),
        'tpl' => 'admin/main/payment_help_tab.tpl',
        'anchor' => 'payment-help',
    );

    if (!empty($active_modules['Amazon_Payments_Advanced'])) {
        $payment_methods_tabs[] = func_amazon_pa_get_payment_tab();
    } elseif (file_exists($xcart_dir . '/skin/common_files/modules/Amazon_Payments_Advanced/payment_tab.tpl')) {
        $payment_methods_tabs[] = array(
            'title' => func_get_langvar_by_name('lbl_amazon_pa_amazon_advanced'),
            'tpl' => 'modules/Amazon_Payments_Advanced/payment_tab.tpl',
            'anchor' => 'payment-amazon-pa',
        );
    }

    $smarty->assign('payment_methods_tabs', $payment_methods_tabs);

    return;
}
