<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Create a thumbnail for X-Magnifier image
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    cf9e608d41c40f761c6416f642a1d0094a6af214, v30 (xcart_4_7_7), 2017-01-24 09:29:34, popup_create_thumbnail.php, aim
 * @link       http://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header("Location: ../../"); die("Access denied"); }

if (empty($imageid)) {
    func_close_window();
}

if (empty($productid))
    $productid = func_query_first_cell("SELECT id FROM $sql_tbl[images_Z] WHERE imageid = '$imageid'");

if (empty($productid)) {
    func_close_window();
}

$thumb_dir = "$xcart_dir/images/Z/$productid/$imageid";
if (!file_exists($thumb_dir)) {
        func_mkdir($thumb_dir);
} elseif (!is_dir($thumb_dir)) {
    echo func_get_langvar_by_name('msg_adm_not_a_directory', array('path' => $thumb_dir), FALSE, TRUE);
    echo '<br /><br /><a href="javascript:window.close()">'.func_get_langvar_by_name("lbl_close_window", FALSE, FALSE, TRUE).'</a>';
    exit;
}

if (!func_check_dir_permissions($thumb_dir.'/')) {
    echo func_get_langvar_by_name('msg_adm_incorrect_store_n_files_perms', array('path' => $thumb_dir), FALSE, TRUE);
    echo '<br /><br /><a href="javascript:window.close()">'.func_get_langvar_by_name("lbl_close_window", FALSE, FALSE, TRUE).'</a>';
    exit;
}

$image = func_query_first("SELECT * FROM $sql_tbl[images_Z] WHERE imageid='$imageid'");

$image_path = $image['image_path'];
if (empty($image_path)) {
    $dir = @opendir($thumb_dir);
    if ($dir) {
        while ($f = readdir($dir)) {
            if (strncmp('level_0.', $f, 8) === 0 && is_file($xcart_dir.'/images/Z/'.$productid.'/'.$imageid.'/'.$f)) {
                $image_path = $xcart_dir.'/images/Z/'.$productid.'/'.$imageid.'/'.$f;
                break;
            }
        }
        closedir($dir);
    }

} else {
    $tmp = pathinfo($image_path);
    $image_path = $xcart_dir.'/images/Z/'.$productid.'/'.$imageid.'/level_0.'.$tmp['extension'];
}

if (empty($image_path) || !file_exists($image_path)) {
    echo func_get_langvar_by_name('msg_adm_no_thumbnail_image', array(), false, true);
    echo '<br /><br /><a href="javascript:window.close()">'.func_get_langvar_by_name("lbl_close_window", false, false, true).'</a>';
    exit;
}

/**
 * Check input data
 */
if ($REQUEST_METHOD == 'POST') {
    $productid = func_query_first_cell("SELECT id FROM $sql_tbl[images_Z] WHERE imageid = '$imageid'");

    $tmp = pathinfo($image_path);
    func_create_thumbnail($image_path, $x0, $y0, $x1, $y1, $xcart_dir.'/images/Z/'.$image['id'].'/'.$imageid.'/', $tmp['extension']);

    echo "<script type=\"text/javascript\">
    var i = window.opener.document.getElementById('thmb_$imageid');
    if (i)
        i.getElementsByTagName('IMG')[0].src = \"".$current_location."/images/Z/".$image["id"]."/".$imageid."/thumbnail.".$tmp["extension"]."?".XC_TIME."\";
</script>";

    func_close_window();
}

$smarty->assign('level0_path', $current_location.'/images/Z/'.$productid.'/'.$imageid.'/'.basename($image_path));
$smarty->assign('imageid', $imageid);
$smarty->assign('productid', $productid);

func_display('modules/Magnifier/popup_create_thumbnail.tpl', $smarty);
?>
