<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Products search interface
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Customer interface
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    cf9e608d41c40f761c6416f642a1d0094a6af214, v80 (xcart_4_7_7), 2017-01-24 09:29:34, search.php, aim
 * @link       http://www.x-cart.com/
 * @see        ____file_see____
 */

define('NUMBER_VARS', "posted_data['price_min'],posted_data['price_max'],posted_data['avail_min'],posted_data['avail_max'],posted_data['weight_min'],posted_data['weight_max'],price_min,price_max,avail_min,avail_max,weight_min,weight_max");

define('STORE_NAVIGATION_SCRIPT', 'Y');

require __DIR__.'/auth.php';

// The list of the fields allowed for searching
$allowable_search_fields = array (
    'substring',
    'by_title',
    'by_descr',
    'by_shortdescr',
    'by_fulldescr',
    'by_sku',
    'extra_fields',
    'by_keywords',
    'categoryid',
    'search_in_subcategories',
    'price_max',
    'price_min',
    'price_max',
    'avail_min',
    'avail_max',
    'weight_min',
    'weight_max',
    'manufacturers',
    'including',
);

$input_args = array();

if (
    $REQUEST_METHOD == 'GET'
    && $mode == 'search'
) {
    // Check the variables passed from GET-request
    $get_vars = array();

    foreach ($_GET as $k => $v) {

        if (in_array($k, $allowable_search_fields)) {

            $get_vars[$k] = $v;

            $input_args[] = func_data2url_query($k, func_stripslashes($v), true);

        }

    }

    // Prepare the search data
    if (!empty($get_vars)) {

        foreach ($get_vars as $k => $v) {

            $search_data['products'][$k] = $v;

        }

        $input_args = implode('&', $input_args);

    }

}

// Update the search statistics
if (
    $REQUEST_METHOD == 'POST'
    && !empty($config['General']['stats_search_max_period'])
    && $mode == 'search'
    && !empty($posted_data['substring'])
) {
    global $sql_tbl, $config, $sql_obj;
    // Delete expired rows
    if (!mt_rand(0, 120)) {
        // For performance purposes use mt_rand
        $_period = $config['General']['stats_search_max_period'] * SECONDS_PER_DAY;
        db_query("DELETE FROM $sql_tbl[stats_search] WHERE date < " . (XC_TIME - $_period));
    }

    $_search_phrase = rtrim(substr($posted_data['substring'], 0, 255), '\\');
    $sql_obj->query_delayed(array('query' => "INSERT INTO $sql_tbl[stats_search]
        (search,date) VALUES
        ('$_search_phrase','" . XC_TIME . "')
        ON DUPLICATE KEY UPDATE count=count+1,date='" . XC_TIME . "'"
    ));
}

$search_data['products']['forsale']         = 'Y';
$search_data['products']['use_cached_ids'] = TRUE;
$search_data['products']['category_main']   = $search_data['products']['category_extra'] = 'Y';

if (!empty($active_modules['Refine_Filters'])) {
    include $xcart_dir . '/modules/Refine_Filters/incl_search.php';
}

if (isset($posted_data)) {

    $posted_data['by_shortdescr'] = $posted_data['by_fulldescr'] = $posted_data['by_descr'];

}

include $xcart_dir . '/include/search.php';

func_unset($search_data['products'], 'forsale', 'use_cached_ids');

if (
    !empty($search_data['products'])
    && !empty($products)
) {

    // Generate the URL of the search result page for accessing it via GET-request
    $search_url_args = array();

    foreach ($search_data['products'] as $k=>$v) {

        if (
            in_array($k, $allowable_search_fields)
            && isset($v)
        ) {

            if (is_array($v)) {

                foreach ($v as $k1 => $v1) {

                    $search_url_args[] = $k . "[" . $k1 . "]=" . urlencode($v1);

                }

            } else {

                $search_url_args[] = "$k=" . urlencode($v);

            }

        }

    }

    if (
        $search_url_args
        && $page > 1
    ) {
        $search_url_args[] = "page=$page";
    }

    $search_url = "search.php?mode=search"
        . (
            !empty($search_url_args)
            ? "&" . implode("&", $search_url_args)
            : ''
        );

    $smarty->assign('search_url', $search_url);
}

$search_prefilled = $search_data['products'];

$search_prefilled_default = array(
    'by_title'      => 'Y',
    'by_descr'      => 'Y',
    'by_sku'        => 'Y',
    'price_min'     => preg_replace("/-.*$/", '', @$config['Search_products']['search_products_price_d']),
    'price_max'     => preg_replace("/^.*-/", '', @$config['Search_products']['search_products_price_d']),
    'weight_min'    => preg_replace("/-.*$/", '', @$config['Search_products']['search_products_weight_d']),
    'weight_max'    => preg_replace("/^.*-/", '', @$config['Search_products']['search_products_weight_d']),
    'categoryid'    => isset($config['Search_products']['search_products_category_d'])
                            ? $config['Search_products']['search_products_category_d']
                            : ''
);

$search_prefilled_default['search_in_subcategories'] = 'Y';

foreach (
    array(
        'price_min',
        'price_max',
        'weight_min',
        'weight_max'
    ) as $k) {

    if (
        $search_prefilled
        && isset($search_prefilled[$k])
        && trim($search_prefilled[$k]) != ''
    ) {
        $search_prefilled[$k] = price_format($search_prefilled[$k]);
    }

    if (
        isset($search_prefilled_default[$k])
        && trim($search_prefilled_default[$k]) != ''
    ) {
        $search_prefilled_default[$k] = price_format($search_prefilled_default[$k]);
    }
}

include $xcart_dir . '/include/common.php';

if (
    !empty($active_modules['Manufacturers'])
    && !empty($manufacturers)
) {

    if (
        $config['Manufacturers']['manufacturers_limit'] > 0
        && count($manufacturers) == $config['Manufacturers']['manufacturers_limit']
    ) {
        $manufacturers = func_get_manufacturers_list(true);
    }

    $search_prefilled_default['manufacturerids'] = func_manufacturer_selected_for_search(
        $manufacturers,
        (
            isset($search_prefilled['manufacturers'])
                ? $search_prefilled['manufacturers']
                : false
        )
    );

    $smarty->assign('manufacturers', $manufacturers);

}

if (!empty($search_prefilled)) {

    foreach ($search_prefilled_default as $k => $v) {

        if (!isset($search_prefilled[$k]) && $v) {

            $search_prefilled[$k] = $v;

            $search_prefilled['need_advanced_options'] = true;

        }

    }

} else {

    $smarty->assign('is_empty_search_prefilled', true);

    $search_prefilled = $search_prefilled_default;

    foreach ($search_prefilled_default as $v) {

        if ($v) {

            $search_prefilled['need_advanced_options'] = true;

        }

    }

}

$smarty->assign('search_prefilled_default', $search_prefilled_default);
$smarty->assign('search_prefilled',         $search_prefilled);

if (
    $REQUEST_METHOD == 'GET'
    && $mode == 'search'
    && empty($products)
    && empty($top_message['content'])
) {
    $smarty->assign(
        'top_message',
        array(
            'type'    => 'W',
            'content' => func_get_langvar_by_name("lbl_warning_no_search_results", false, false, true)
        )
    );
}

if (!zerolen(func_qs_remove($QUERY_STRING, $XCART_SESSION_NAME))) {

    $location[] = array(func_get_langvar_by_name('lbl_search_results'), '');

    $smarty->assign('main', 'search');

} else {

    $location[] = array(func_get_langvar_by_name('lbl_advanced_search'), '');

    $smarty->assign('main', 'advanced_search');

}

if (!empty($active_modules['Gift_Registry'])) {

    include $xcart_dir . '/modules/Gift_Registry/customer_events.php';

}

// Assign the current location line
$smarty->assign('location', $location);

func_display('customer/home.tpl', $smarty);
?>
