CREATE TABLE IF NOT EXISTS xcart_pilibaba_service_orders (
  reserve_pilibaba_oid int(11) unsigned NOT NULL AUTO_INCREMENT,
  ref char(32) NOT NULL DEFAULT '' COMMENT 'Generated by func_generate_n_save_uniqueid',
  expire int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (reserve_pilibaba_oid),
  KEY expire (expire)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS xcart_pilibaba_data (
  ref varchar(255) NOT NULL DEFAULT '',
  sessid binary(32) NOT NULL COMMENT 'Use func_binary_empty',
  cart mediumblob NOT NULL COMMENT 'binary-safe blob is used to avoid data corruption with php unserialize function',
  expire int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (ref),
  KEY sessid (sessid)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


INSERT INTO xcart_modules SET module_name='Pilibaba', module_descr='Start accepting CNY payment and take orders from 1.3 Billion shoppers in China. Support all Chinese debit/credit cards and give merchants the flexibility to convert CNY payment into either USD,EUR or 12 supported currencies.', active='N', author='qualiteam', tags='checkout';


INSERT INTO xcart_config SET name='pilibaba_sep_connection', comment='Connection settings', value='', category='Pilibaba', orderby='10', type='separator', defvalue='', variants='';


INSERT INTO xcart_config SET name='pilibaba_merchant_no', comment='Merchant NO', value='', category='Pilibaba', orderby='20', type='trimmed_text', defvalue='', variants='';
INSERT INTO xcart_config SET name='pilibaba_secret_key', comment='Secret key', value='', category='Pilibaba', orderby='30', type='trimmed_text', defvalue='', variants='';
INSERT INTO xcart_config SET name='pilibaba_mode', comment='Test/Live mode', value='test', category='Pilibaba', orderby='40', type='selector', defvalue='test', variants='live:lbl_live\r\ntest:lbl_test';

INSERT INTO xcart_config SET name='pilibaba_checkout_connection', comment='Checkout settings', value='', category='Pilibaba', orderby='100', type='separator', defvalue='', variants='';

INSERT INTO xcart_config SET name='pilibaba_currency', comment='Currency', value='USD', category='Pilibaba', orderby='110', type='selector', defvalue='USD', variants='func_pilibaba_get_currencies';
INSERT INTO xcart_config SET name='pilibaba_prefix', comment='Order prefix', value='', category='Pilibaba', orderby='120', type='trimmed_text', defvalue='', variants='', validation='';
INSERT INTO xcart_config SET name='pilibaba_shipping_fee', comment='Shipping fee', value='0', category='Pilibaba', orderby='130', type='text', defvalue='0', variants='', validation='double';
INSERT INTO xcart_config SET name='pilibaba_warehouse_address', comment='Warehouse Address', value='', category='Pilibaba', orderby='140', type='selector', defvalue='', variants='func_pilibaba_get_warehouse_addresses';

INSERT INTO xcart_config SET name='pilibaba_display_including_tax', comment='Override the \"Display product price including tax\" option for product prices sent to Pilibaba.', value='N', category='Pilibaba', orderby='150', type='checkbox', defvalue='N', variants='';


CREATE TABLE xcart_pilibaba_func_not_compatible (value varchar(32));
INSERT INTO xcart_pilibaba_func_not_compatible SELECT value FROM xcart_config WHERE name='version' AND value<'4.6.5';
DELETE xcart_config FROM xcart_config INNER JOIN xcart_pilibaba_func_not_compatible WHERE name='pilibaba_display_including_tax';
DROP TABLE xcart_pilibaba_func_not_compatible;
