<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * This script contains common functions for DHL shipping module
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Cart
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    0b0633768559e57d1124488556a9dbf71d865723, v8 (xcart_4_7_7), 2017-01-23 20:12:10, func.dhl.php, aim
 * @link       http://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }

abstract class XCDHLReferenceData { //{{{

    protected static $DHL_countries = array( //{{{
        array(
            'country_code' => 'AD',
            'country' => 'Andorra',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AE',
            'country' => 'United Arab Emirates',
            'currency_code' => 'AED',
            'currency' => 'UAE Dirham',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'County',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AF',
            'country' => 'Afghanistan',
            'currency_code' => 'AFN',
            'currency' => 'Afghan Afghani',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'Suburb',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AG',
            'country' => 'Antigua',
            'currency_code' => 'XCD',
            'currency' => 'East Caribbean Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AI',
            'country' => 'Anguilla',
            'currency_code' => 'XCD',
            'currency' => 'East Caribbean Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AL',
            'country' => 'Albania',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AM',
            'country' => 'Armenia',
            'currency_code' => 'AMD',
            'currency' => 'Armenian Dram',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'County',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'AN',
            'country' => 'Netherlands Antilles',
            'currency_code' => 'ANG',
            'currency' => 'Netherlands Antilles Guilder',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'County',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AO',
            'country' => 'Angola',
            'currency_code' => 'AOA',
            'currency' => 'Kwanza',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AR',
            'country' => 'Argentina',
            'currency_code' => 'ARS',
            'currency' => 'Argentine Peso',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AS',
            'country' => 'American Samoa',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AT',
            'country' => 'Austria',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AU',
            'country' => 'Australia',
            'currency_code' => 'AUD',
            'currency' => 'Australian Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '9999',
            'country_division_type' => 'State',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'AW',
            'country' => 'Aruba',
            'currency_code' => 'AWG',
            'currency' => 'Aruba Guilder',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'AZ',
            'country' => 'Azerbaijan',
            'currency_code' => 'AZN',
            'currency' => 'Azerbaijan Manat',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999999, 9999',
            'country_division_type' => 'County',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BA',
            'country' => 'Bosnia and Herzegovina',
            'currency_code' => 'BAM',
            'currency' => 'Convertible Marks',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'County',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BB',
            'country' => 'Barbados',
            'currency_code' => 'BBD',
            'currency' => 'Barbadian Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BD',
            'country' => 'Bangladesh',
            'currency_code' => 'BDT',
            'currency' => 'Taka',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'County',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BE',
            'country' => 'Belgium',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '9999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'BF',
            'country' => 'Burkina Faso',
            'currency_code' => 'XOF',
            'currency' => 'CFA Franc - West Africa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BG',
            'country' => 'Bulgaria',
            'currency_code' => 'BGN',
            'currency' => 'Bulgarian Lev',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BH',
            'country' => 'Bahrain',
            'currency_code' => 'BHD',
            'currency' => 'Bahraini Dinar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BI',
            'country' => 'Burundi',
            'currency_code' => 'BIF',
            'currency' => 'Burundese Franc',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BJ',
            'country' => 'Benin',
            'currency_code' => 'XOF',
            'currency' => 'CFA Franc - West Africa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BM',
            'country' => 'Bermuda',
            'currency_code' => 'BMD',
            'currency' => 'Bermudian Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BN',
            'country' => 'Brunei',
            'currency_code' => 'BND',
            'currency' => 'Brunei Dollar',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => 'AA9999',
            'country_division_type' => 'County',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'BO',
            'country' => 'Bolivia',
            'currency_code' => 'BOB',
            'currency' => 'Boliviano',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BR',
            'country' => 'Brazil',
            'currency_code' => 'BRL',
            'currency' => 'Real',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999,99999-999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BS',
            'country' => 'Bahamas',
            'currency_code' => 'BSD',
            'currency' => 'Bahamian Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BT',
            'country' => 'Bhutan',
            'currency_code' => 'BTN',
            'currency' => 'Ngultrum',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BW',
            'country' => 'Botswana',
            'currency_code' => 'BWP',
            'currency' => 'Pula',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'BY',
            'country' => 'Belarus',
            'currency_code' => 'BYN',
            'currency' => 'Belarusian Ruble',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '999999',
            'country_division_type' => 'County',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'BZ',
            'country' => 'Belize',
            'currency_code' => 'BZD',
            'currency' => 'Belize Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CA',
            'country' => 'Canada',
            'currency_code' => 'CAD',
            'currency' => 'Canadian Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => 'A9A 9A9,A9A 9A',
            'country_division_type' => 'Province',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'CD',
            'country' => 'Congo, The Democratic Republic of',
            'currency_code' => 'CDF',
            'currency' => 'Congolese Franc',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CF',
            'country' => 'Central African Republic',
            'currency_code' => 'XAF',
            'currency' => 'CFA Franc - Central Africa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CG',
            'country' => 'Congo',
            'currency_code' => 'XAF',
            'currency' => 'CFA Franc - Central Africa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CH',
            'country' => 'Switzerland',
            'currency_code' => 'CHF',
            'currency' => 'Swiss Franc',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'CI',
            'country' => 'Cote d\'Ivoire',
            'currency_code' => 'XOF',
            'currency' => 'CFA Franc - West Africa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CK',
            'country' => 'Cook Islands',
            'currency_code' => 'NZD',
            'currency' => 'New Zealand Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CL',
            'country' => 'Chile',
            'currency_code' => 'CLP',
            'currency' => 'New Chile Peso',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CM',
            'country' => 'Cameroon',
            'currency_code' => 'XAF',
            'currency' => 'CFA Franc - Central Africa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CN',
            'country' => 'China, People\'s Republic',
            'currency_code' => 'CNY',
            'currency' => 'Yuan (Ren Min Bi)',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'CO',
            'country' => 'Colombia',
            'currency_code' => 'COP',
            'currency' => 'Colombian Peso',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CR',
            'country' => 'Costa Rica',
            'currency_code' => 'CRC',
            'currency' => 'Costa Rican Colon',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CU',
            'country' => 'Cuba',
            'currency_code' => 'CUC',
            'currency' => 'Cuban Peso',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CV',
            'country' => 'Cape Verde',
            'currency_code' => 'CVE',
            'currency' => 'Cape Verde Escudo',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'CY',
            'country' => 'Cyprus',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'CZ',
            'country' => 'Czech Republic, The',
            'currency_code' => 'CZK',
            'currency' => 'Czech Koruna',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '999 99',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'DE',
            'country' => 'Germany',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'DJ',
            'country' => 'Djibouti',
            'currency_code' => 'DJF',
            'currency' => 'Djibouti Franc',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'DK',
            'country' => 'Denmark',
            'currency_code' => 'DKK',
            'currency' => 'Danish Krone',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'DM',
            'country' => 'Dominica',
            'currency_code' => 'XCD',
            'currency' => 'East Caribbean Dollar',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'DO',
            'country' => 'Dominican Rep.',
            'currency_code' => 'DOP',
            'currency' => 'Dominican Republic Peso',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => '',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'DZ',
            'country' => 'Algeria',
            'currency_code' => 'DZD',
            'currency' => 'Algerian Dinar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'EC',
            'country' => 'Ecuador',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'EE',
            'country' => 'Estonia',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'EG',
            'country' => 'Egypt',
            'currency_code' => 'EGP',
            'currency' => 'Egyptian Pound',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'ER',
            'country' => 'Eritrea',
            'currency_code' => 'ERN',
            'currency' => 'Nakfa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'ES',
            'country' => 'Spain',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'ET',
            'country' => 'Ethiopia',
            'currency_code' => 'ETB',
            'currency' => 'Birr',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'FI',
            'country' => 'Finland',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'FJ',
            'country' => 'Fiji',
            'currency_code' => 'FJD',
            'currency' => 'Fijian Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'FK',
            'country' => 'Falkland Islands',
            'currency_code' => 'GBP',
            'currency' => 'Pound Sterling',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'FM',
            'country' => 'Micronesia, Federated States Of',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'FO',
            'country' => 'Faroe Islands',
            'currency_code' => 'DKK',
            'currency' => 'Danish Krone',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'FR',
            'country' => 'France',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GA',
            'country' => 'Gabon',
            'currency_code' => 'XAF',
            'currency' => 'CFA Franc - Central Africa',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GB',
            'country' => 'United Kingdom',
            'currency_code' => 'GBP',
            'currency' => 'Pound Sterling',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => 'A9 9AA, A99 9AA, A9A 9AA, AA9 9AA, AA99 9AA, AA9A 9AA',
            'country_division_type' => 'County',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'GD',
            'country' => 'Grenada',
            'currency_code' => 'XCD',
            'currency' => 'East Caribbean Dollar',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GE',
            'country' => 'Georgia',
            'currency_code' => 'GEL',
            'currency' => 'Georgian Lari',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'County',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GF',
            'country' => 'French Guyana',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GG',
            'country' => 'Guernsey',
            'currency_code' => 'GBP',
            'currency' => 'Pound Sterling',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => 'AA9 9AA',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GH',
            'country' => 'Ghana',
            'currency_code' => 'GHS',
            'currency' => 'Cedi',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GI',
            'country' => 'Gibraltar',
            'currency_code' => 'GBP',
            'currency' => 'Pound Sterling',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GL',
            'country' => 'Greenland',
            'currency_code' => 'DKK',
            'currency' => 'Danish Krone',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GM',
            'country' => 'Gambia',
            'currency_code' => 'GMD',
            'currency' => 'Dalasi',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GN',
            'country' => 'Guinea Republic',
            'currency_code' => 'GNF',
            'currency' => 'Guinea Franc',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GP',
            'country' => 'Guadeloupe',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GQ',
            'country' => 'Guinea-Equatorial',
            'currency_code' => 'XAF',
            'currency' => 'CFA Franc - Central Africa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GR',
            'country' => 'Greece',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '999 99',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'GT',
            'country' => 'Guatemala',
            'currency_code' => 'GTQ',
            'currency' => 'Quetzal',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GU',
            'country' => 'Guam',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GW',
            'country' => 'Guinea-Bissau',
            'currency_code' => 'XOF',
            'currency' => 'CFA Franc',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'GY',
            'country' => 'Guyana (British)',
            'currency_code' => 'GYD',
            'currency' => 'Guyanan Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'HK',
            'country' => 'Hong Kong',
            'currency_code' => 'HKD',
            'currency' => 'Hong Kong Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'HN',
            'country' => 'Honduras',
            'currency_code' => 'HNL',
            'currency' => 'Lempira',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'HR',
            'country' => 'Croatia',
            'currency_code' => 'HRK',
            'currency' => 'Croatian Kuna',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'HT',
            'country' => 'Haiti',
            'currency_code' => 'HTG',
            'currency' => 'Gourde',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'HU',
            'country' => 'Hungary',
            'currency_code' => 'HUF',
            'currency' => 'Forint',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'IC',
            'country' => 'Canary Islands, The',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Autonomous community',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'ID',
            'country' => 'Indonesia',
            'currency_code' => 'IDR',
            'currency' => 'Rupiah',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'IE',
            'country' => 'Ireland, Republic Of',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'County',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'IL',
            'country' => 'Israel',
            'currency_code' => 'ILS',
            'currency' => 'New Israeli Shekel',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'IN',
            'country' => 'India',
            'currency_code' => 'INR',
            'currency' => 'Indian Rupee',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999999',
            'country_division_type' => 'County',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'IQ',
            'country' => 'Iraq',
            'currency_code' => 'IQD',
            'currency' => 'Iraqi Dinar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'IR',
            'country' => 'Iran (Islamic Republic of)',
            'currency_code' => 'IRR',
            'currency' => 'Iranian Rial',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'IS',
            'country' => 'Iceland',
            'currency_code' => 'ISK',
            'currency' => 'Icelandic Krona',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'IT',
            'country' => 'Italy',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'County',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'JE',
            'country' => 'Jersey',
            'currency_code' => 'GBP',
            'currency' => 'Pound Sterling',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => 'AA9 9AA',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'JM',
            'country' => 'Jamaica',
            'currency_code' => 'JMD',
            'currency' => 'Jamaican Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'JO',
            'country' => 'Jordan',
            'currency_code' => 'JOD',
            'currency' => 'Jordanian Dinar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'JP',
            'country' => 'Japan',
            'currency_code' => 'JPY',
            'currency' => 'Yen',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999-9999',
            'country_division_type' => 'State',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'KE',
            'country' => 'Kenya',
            'currency_code' => 'KES',
            'currency' => 'Kenyan Shilling',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'KG',
            'country' => 'Kyrgyzstan',
            'currency_code' => 'KGS',
            'currency' => 'Kyrgyzstanian Som',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999999',
            'country_division_type' => 'County',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'KH',
            'country' => 'Cambodia',
            'currency_code' => 'KHR',
            'currency' => 'KhmerRial',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'KI',
            'country' => 'Kiribati',
            'currency_code' => 'AUD',
            'currency' => 'Australian Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'KM',
            'country' => 'Comoros',
            'currency_code' => 'KMF',
            'currency' => 'Comoros Franc',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'KN',
            'country' => 'St. Kitts',
            'currency_code' => 'XCD',
            'currency' => 'East Caribbean Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'KP',
            'country' => 'Korea, The D.P.R of',
            'currency_code' => 'KPW',
            'currency' => 'North Korean Won',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'KR',
            'country' => 'Korea, Republic Of',
            'currency_code' => 'KRW',
            'currency' => 'Korean Won',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '999-999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'KV',
            'country' => 'Kosovo',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'KW',
            'country' => 'Kuwait',
            'currency_code' => 'KWD',
            'currency' => 'Kuwaiti Dinar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'KY',
            'country' => 'Cayman Islands',
            'currency_code' => 'KYD',
            'currency' => 'Cayman Islands Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'KZ',
            'country' => 'Kazakhstan',
            'currency_code' => 'KZT',
            'currency' => 'Tenge',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '999999',
            'country_division_type' => 'County',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'LA',
            'country' => 'Lao People\'s Democratic Republic',
            'currency_code' => 'LAK',
            'currency' => 'Kip',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'LB',
            'country' => 'Lebanon',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'LC',
            'country' => 'St. Lucia',
            'currency_code' => 'XCD',
            'currency' => 'East Caribbean Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'LI',
            'country' => 'Liechtenstein',
            'currency_code' => 'CHF',
            'currency' => 'Swiss Franc',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'LK',
            'country' => 'Sri Lanka',
            'currency_code' => 'LKR',
            'currency' => 'Sri Lankan Rupee',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'LR',
            'country' => 'Liberia',
            'currency_code' => 'LRD',
            'currency' => 'Liberian Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'LS',
            'country' => 'Lesotho',
            'currency_code' => 'LSL',
            'currency' => 'Loti',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'LT',
            'country' => 'Lithuania',
            'currency_code' => 'LTL',
            'currency' => 'Lithuanian Litas',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'LU',
            'country' => 'Luxembourg',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '9999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'LV',
            'country' => 'Latvia',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'LY',
            'country' => 'Libya',
            'currency_code' => 'LYD',
            'currency' => 'Libyan Dinar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MA',
            'country' => 'Morocco',
            'currency_code' => 'MAD',
            'currency' => 'Moroccan Dirham',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MC',
            'country' => 'Monaco',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MD',
            'country' => 'Moldova, Republic Of',
            'currency_code' => 'MDL',
            'currency' => 'Moldovan Leu',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '9999',
            'country_division_type' => 'County',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'ME',
            'country' => 'Montenegro, Republic of',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MG',
            'country' => 'Madagascar',
            'currency_code' => 'MGA',
            'currency' => 'Ariary',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MH',
            'country' => 'Marshall Islands',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MK',
            'country' => 'Macedonia, Rep. of (FYROM)',
            'currency_code' => 'MKD',
            'currency' => 'Macedonian Denar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'ML',
            'country' => 'Mali',
            'currency_code' => 'XOF',
            'currency' => 'CFA Franc - West Africa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MM',
            'country' => 'Myanmar',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MN',
            'country' => 'Mongolia',
            'currency_code' => 'MNT',
            'currency' => 'Tugrik',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999999, 99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MO',
            'country' => 'Macau',
            'currency_code' => 'MOP',
            'currency' => 'Pataca',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MP',
            'country' => 'Saipan',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'MQ',
            'country' => 'Martinique',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MR',
            'country' => 'Mauritania',
            'currency_code' => 'MRO',
            'currency' => 'Ouguiya',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MS',
            'country' => 'Montserrat',
            'currency_code' => 'XCD',
            'currency' => 'East Caribbean Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MT',
            'country' => 'Malta',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MU',
            'country' => 'Mauritius',
            'currency_code' => 'MUR',
            'currency' => 'Mauritius Rupee',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MV',
            'country' => 'Maldives',
            'currency_code' => 'MVR',
            'currency' => 'Rufiyaa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999, 9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MW',
            'country' => 'Malawi',
            'currency_code' => 'MWK',
            'currency' => 'Malawi Kwacha',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'MX',
            'country' => 'Mexico',
            'currency_code' => 'MXN',
            'currency' => 'Mexican Peso',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'MY',
            'country' => 'Malaysia',
            'currency_code' => 'MYR',
            'currency' => 'Ringgit',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'MZ',
            'country' => 'Mozambique',
            'currency_code' => 'MZN',
            'currency' => 'Mozambique Metical',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'NA',
            'country' => 'Namibia',
            'currency_code' => 'NAD',
            'currency' => 'Namibian Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'NC',
            'country' => 'New Caledonia',
            'currency_code' => 'XPF',
            'currency' => 'CFP Franc',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'NE',
            'country' => 'Niger',
            'currency_code' => 'XOF',
            'currency' => 'CFA Franc - West Africa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'NG',
            'country' => 'Nigeria',
            'currency_code' => 'NGN',
            'currency' => 'Naira',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'NI',
            'country' => 'Nicaragua',
            'currency_code' => 'NIO',
            'currency' => 'Cordoba Oro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'NL',
            'country' => 'Netherlands, The',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'NO',
            'country' => 'Norway',
            'currency_code' => 'NOK',
            'currency' => 'Norwegian Krone',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '9999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'NP',
            'country' => 'Nepal',
            'currency_code' => 'NPR',
            'currency' => 'Nepalese Rupee',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'NR',
            'country' => 'Nauru, Republic Of',
            'currency_code' => 'AUD',
            'currency' => 'Australian Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'NU',
            'country' => 'Niue',
            'currency_code' => 'NZD',
            'currency' => 'New Zealand Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'NZ',
            'country' => 'New Zealand',
            'currency_code' => 'NZD',
            'currency' => 'New Zealand Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'Country region',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'OM',
            'country' => 'Oman',
            'currency_code' => 'OMR',
            'currency' => 'Omani Rial',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'PA',
            'country' => 'Panama',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'PE',
            'country' => 'Peru',
            'currency_code' => 'PEN',
            'currency' => 'Sol',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'PF',
            'country' => 'Tahiti',
            'currency_code' => 'XPF',
            'currency' => 'CFP Franc',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'PG',
            'country' => 'Papua New Guinea',
            'currency_code' => 'PGK',
            'currency' => 'Kina',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '999',
            'country_division_type' => 'Province',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'PH',
            'country' => 'Philippines, The',
            'currency_code' => 'PHP',
            'currency' => 'Phillipines Peso',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'County',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'PK',
            'country' => 'Pakistan',
            'currency_code' => 'PKR',
            'currency' => 'Pakistani Rupee',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'PL',
            'country' => 'Poland',
            'currency_code' => 'PLN',
            'currency' => 'Zloty',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99-999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'PR',
            'country' => 'Puerto Rico',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'PT',
            'country' => 'Portugal',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999, 9999-999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'PW',
            'country' => 'Palau',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'PY',
            'country' => 'Paraguay',
            'currency_code' => 'PYG',
            'currency' => 'Guarani',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'QA',
            'country' => 'Qatar',
            'currency_code' => 'QAR',
            'currency' => 'QatarRial',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'RE',
            'country' => 'Reunion, Island Of',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'RO',
            'country' => 'Romania',
            'currency_code' => 'RON',
            'currency' => 'Leu',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '999999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'RS',
            'country' => 'Serbia, Republic of',
            'currency_code' => 'RSD',
            'currency' => 'Serbia, Dinars',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'RU',
            'country' => 'Russian Federation, The',
            'currency_code' => 'RUB',
            'currency' => 'Russian Ruble',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '999999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'RW',
            'country' => 'Rwanda',
            'currency_code' => 'RWF',
            'currency' => 'Rwanda Franc',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SA',
            'country' => 'Saudi Arabia',
            'currency_code' => 'SAR',
            'currency' => 'Saudi Riyal',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SB',
            'country' => 'Solomon Islands',
            'currency_code' => 'SBD',
            'currency' => 'Solomon Islands Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SC',
            'country' => 'Seychelles',
            'currency_code' => 'SCR',
            'currency' => 'Seychelles Rupee',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SD',
            'country' => 'Sudan',
            'currency_code' => 'SDG',
            'currency' => 'Sudanese Pound',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SE',
            'country' => 'Sweden',
            'currency_code' => 'SEK',
            'currency' => 'Swedish Krona',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '999 99',
            'country_division_type' => 'County',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SG',
            'country' => 'Singapore',
            'currency_code' => 'SGD',
            'currency' => 'Singapore Dollar',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999999',
            'country_division_type' => 'State',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SH',
            'country' => 'SAINT HELENA',
            'currency_code' => 'SHP',
            'currency' => 'Saint Helenian Pound',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Not available',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SI',
            'country' => 'Slovenia',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '9999',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SK',
            'country' => 'Slovakia',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '999 99',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SL',
            'country' => 'Sierra Leone',
            'currency_code' => 'SLL',
            'currency' => 'Sierra Leonean Leone',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SM',
            'country' => 'San Marino',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SN',
            'country' => 'Senegal',
            'currency_code' => 'XOF',
            'currency' => 'CFA Franc - West Africa',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SO',
            'country' => 'Somalia',
            'currency_code' => 'SOS',
            'currency' => 'Somali Shilling',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SR',
            'country' => 'Suriname',
            'currency_code' => 'SRD',
            'currency' => 'Surinamese Dollar',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SS',
            'country' => 'SOUTH SUDAN',
            'currency_code' => 'SSP',
            'currency' => 'South Sudanese pound',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Not available',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'ST',
            'country' => 'Sao Tome and Principe',
            'currency_code' => 'STD',
            'currency' => 'Sao Tomean Dobra',
            'weight' => 'LB',
            'dimencional_unit' => 'IN',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SV',
            'country' => 'El Salvador',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SY',
            'country' => 'Syria',
            'currency_code' => 'SYP',
            'currency' => 'Syrian Pound',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Province',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'SZ',
            'country' => 'Swaziland',
            'currency_code' => 'SZL',
            'currency' => 'Swazi Lilangeni',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => 'A999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'TC',
            'country' => 'Turks and Caicos Islands',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'TD',
            'country' => 'Chad',
            'currency_code' => 'XAF',
            'currency' => 'CFA Franc - Central Africa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'TG',
            'country' => 'Togo',
            'currency_code' => 'XOF',
            'currency' => 'CFA Franc - West Africa',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'TH',
            'country' => 'Thailand',
            'currency_code' => 'THB',
            'currency' => 'Baht',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'TJ',
            'country' => 'Tajikistan',
            'currency_code' => 'TJS',
            'currency' => 'Tajikistani Somoni',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999999',
            'country_division_type' => 'County',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'TL',
            'country' => 'East Timor',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Not available',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'TN',
            'country' => 'Tunisia',
            'currency_code' => 'TND',
            'currency' => 'Tunisian Dinar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'TO',
            'country' => 'Tonga',
            'currency_code' => 'TOP',
            'currency' => 'Pa\'anga',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'TR',
            'country' => 'Turkey',
            'currency_code' => 'TRY',
            'currency' => 'New Turkish Lira',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'TT',
            'country' => 'Trinidad and Tobago',
            'currency_code' => 'TTD',
            'currency' => 'Trinidad and Tobago Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'TV',
            'country' => 'Tuvalu',
            'currency_code' => 'AUD',
            'currency' => 'Australian Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'TW',
            'country' => 'Taiwan',
            'currency_code' => 'TWD',
            'currency' => 'New Taiwan Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999, 99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'TZ',
            'country' => 'Tanzania',
            'currency_code' => 'TZS',
            'currency' => 'Tanzanian Shilling',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'UA',
            'country' => 'Ukraine',
            'currency_code' => 'UAH',
            'currency' => 'Hryvna',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'State',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'UG',
            'country' => 'Uganda',
            'currency_code' => 'USD',
            'currency' => 'Ugandan Shilling',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'US',
            'country' => 'United States Of America',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999, 99999-9999',
            'country_division_type' => 'State',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'UY',
            'country' => 'Uruguay',
            'currency_code' => 'UYU',
            'currency' => 'Peso Uruguayo',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'UZ',
            'country' => 'Uzbekistan',
            'currency_code' => 'UZS',
            'currency' => 'Uzbekistan Som',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '999999',
            'country_division_type' => 'County',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'VC',
            'country' => 'St. Vincent',
            'currency_code' => 'XCD',
            'currency' => 'East Caribbean Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'VE',
            'country' => 'Venezuela',
            'currency_code' => 'VEF',
            'currency' => 'BolivarFuerte',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'Suburb',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'VG',
            'country' => 'Virgin Islands (British)',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'VI',
            'country' => 'Virgin Islands (US)',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'VN',
            'country' => 'Vietnam',
            'currency_code' => 'VND',
            'currency' => 'Dong',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'VU',
            'country' => 'Vanuatu',
            'currency_code' => 'VUV',
            'currency' => 'Vanuatu Vatu',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'WS',
            'country' => 'Samoa',
            'currency_code' => 'WST',
            'currency' => 'Samoan Tala',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'XB',
            'country' => 'Bonaire',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'XC',
            'country' => 'Curacao',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'XE',
            'country' => 'St. Eustatius',
            'currency_code' => 'ANG',
            'currency' => 'Netherlands Antilles Guilder',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'XM',
            'country' => 'St. Maarten',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'XN',
            'country' => 'Nevis',
            'currency_code' => 'XCD',
            'currency' => 'East Caribbean Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'XS',
            'country' => 'Somaliland, Rep of (North Somalia)',
            'currency_code' => 'SIS',
            'currency' => 'Somaliland shilling',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Country-use when no divtype identify',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'XY',
            'country' => 'St. Barthelemy',
            'currency_code' => 'ANG',
            'currency' => 'Netherlands Antilles Guilder',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'YE',
            'country' => 'Yemen, Republic of',
            'currency_code' => 'YER',
            'currency' => 'Yemeni Riyal',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'YT',
            'country' => 'Mayotte',
            'currency_code' => 'EUR',
            'currency' => 'Euro',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '99999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'ZA',
            'country' => 'South Africa',
            'currency_code' => 'ZAR',
            'currency' => 'South African Rand',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'City Postcode',
            'postal_code_format' => '9999',
            'country_division_type' => 'Migration',
            'country_use_division' => 'Y',
        ),
        array(
            'country_code' => 'ZM',
            'country' => 'Zambia',
            'currency_code' => 'ZMW',
            'currency' => 'Zambian Kwacha',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'Suburb',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
        array(
            'country_code' => 'ZW',
            'country' => 'Zimbabwe',
            'currency_code' => 'USD',
            'currency' => 'US Dollar',
            'weight' => 'KG',
            'dimencional_unit' => 'CM',
            'location_type' => 'Postcode',
            'postal_code_format' => '',
            'country_division_type' => 'Migration',
            'country_use_division' => 'N',
        ),
    ); //}}}

    protected static $DHL_products = array( //{{{
        array(
            'global_product_code' => '0',
            'global_product_name' => 'LOGISTICS SERVICES',
            'product_content_code' => 'LOG',
            'doc_indicator' => 'A-Not Applicable',
            'service_default_delivery_time' => '',
        ),
        array(
            'global_product_code' => '1',
            'global_product_name' => 'DOMESTIC EXPRESS 12:00',
            'product_content_code' => 'DOT',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '12:00',
        ),
        array(
            'global_product_code' => '2',
            'global_product_name' => 'B2C',
            'product_content_code' => 'BTC',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => '3',
            'global_product_name' => 'B2C',
            'product_content_code' => 'B2C',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => '4',
            'global_product_name' => 'JETLINE',
            'product_content_code' => 'NFO',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => '5',
            'global_product_name' => 'SPRINTLINE',
            'product_content_code' => 'SPL',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => '7',
            'global_product_name' => 'EXPRESS EASY',
            'product_content_code' => 'XED',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => '8',
            'global_product_name' => 'EXPRESS EASY',
            'product_content_code' => 'XEP',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => '9',
            'global_product_name' => 'EUROPACK',
            'product_content_code' => 'EPA',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'A',
            'global_product_name' => 'AUTO REVERSALS',
            'product_content_code' => 'N/A',
            'doc_indicator' => 'A-Not Applicable',
            'service_default_delivery_time' => '',
        ),
        array(
            'global_product_code' => 'B',
            'global_product_name' => 'BREAKBULK EXPRESS',
            'product_content_code' => 'BBX',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'C',
            'global_product_name' => 'MEDICAL EXPRESS',
            'product_content_code' => 'CMX',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'D',
            'global_product_name' => 'EXPRESS WORLDWIDE',
            'product_content_code' => 'DOX',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'E',
            'global_product_name' => 'EXPRESS 9:00',
            'product_content_code' => 'TDE',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '09:00',
        ),
        array(
            'global_product_code' => 'F',
            'global_product_name' => 'FREIGHT WORLDWIDE',
            'product_content_code' => 'FRT',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'G',
            'global_product_name' => 'DOMESTIC ECONOMY SELECT',
            'product_content_code' => 'DES',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'H',
            'global_product_name' => 'ECONOMY SELECT',
            'product_content_code' => 'ESI',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'I',
            'global_product_name' => 'DOMESTIC EXPRESS 9:00',
            'product_content_code' => 'DOK',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '9:00',
        ),
        array(
            'global_product_code' => 'J',
            'global_product_name' => 'JUMBO BOX',
            'product_content_code' => 'JBX',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'K',
            'global_product_name' => 'EXPRESS 9:00',
            'product_content_code' => 'TDK',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '9:00',
        ),
        array(
            'global_product_code' => 'L',
            'global_product_name' => 'EXPRESS 10:30',
            'product_content_code' => 'TDL',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '10:30',
        ),
        array(
            'global_product_code' => 'M',
            'global_product_name' => 'EXPRESS 10:30',
            'product_content_code' => 'TDM',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '10:30',
        ),
        array(
            'global_product_code' => 'N',
            'global_product_name' => 'DOMESTIC EXPRESS',
            'product_content_code' => 'DOM',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'O',
            'global_product_name' => 'DOMESTIC EXPRESS 10:30',
            'product_content_code' => 'DOL',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '10:30',
        ),
        array(
            'global_product_code' => 'P',
            'global_product_name' => 'EXPRESS WORLDWIDE',
            'product_content_code' => 'WPX',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'Q',
            'global_product_name' => 'MEDICAL EXPRESS',
            'product_content_code' => 'WMX',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'R',
            'global_product_name' => 'GLOBALMAIL BUSINESS',
            'product_content_code' => 'GMB',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'S',
            'global_product_name' => 'SAME DAY',
            'product_content_code' => 'SDX',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'T',
            'global_product_name' => 'EXPRESS 12:00',
            'product_content_code' => 'TDT',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '12:00',
        ),
        array(
            'global_product_code' => 'U',
            'global_product_name' => 'EXPRESS WORLDWIDE',
            'product_content_code' => 'ECX',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'V',
            'global_product_name' => 'EUROPACK',
            'product_content_code' => 'EPP',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'W',
            'global_product_name' => 'ECONOMY SELECT',
            'product_content_code' => 'ESU',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'X',
            'global_product_name' => 'EXPRESS ENVELOPE',
            'product_content_code' => 'XPD',
            'doc_indicator' => 'Y-Doc',
            'service_default_delivery_time' => '23:59',
        ),
        array(
            'global_product_code' => 'Y',
            'global_product_name' => 'EXPRESS 12:00',
            'product_content_code' => 'TDY',
            'doc_indicator' => 'N-Non Doc',
            'service_default_delivery_time' => '12:00',
        ),
        array(
            'global_product_code' => 'Z',
            'global_product_name' => 'Destination Charges',
            'product_content_code' => 'N/A',
            'doc_indicator' => 'A-Not Applicable',
            'service_default_delivery_time' => '',
        ),
    ); //}}}

    protected static $DHL_services = array( //{{{
        array(
            'special_service_code' => '0A',
            'global_service_name' => 'Logistics Services',
            'service_group_code' => '0 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0B',
            'global_service_name' => 'Mailroom Management',
            'service_group_code' => '1 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0C',
            'global_service_name' => 'Pallet Administration',
            'service_group_code' => '2 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0D',
            'global_service_name' => 'Warehousing',
            'service_group_code' => '3 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0E',
            'global_service_name' => 'Express Logistics Centre',
            'service_group_code' => '4 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0F',
            'global_service_name' => 'Strategic Parts Centre',
            'service_group_code' => '5 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0G',
            'global_service_name' => 'Local Distribution Centre',
            'service_group_code' => '6 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0H',
            'global_service_name' => 'Terminal Handling',
            'service_group_code' => '7 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0I',
            'global_service_name' => 'Cross Docking',
            'service_group_code' => '8 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0J',
            'global_service_name' => 'Inventory Management',
            'service_group_code' => '9 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0K',
            'global_service_name' => 'Loading/Unloading',
            'service_group_code' => '10 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0L',
            'global_service_name' => 'Product Kitting',
            'service_group_code' => '11 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0M',
            'global_service_name' => 'Priority Account Desk',
            'service_group_code' => '12 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0N',
            'global_service_name' => 'Document Archiving',
            'service_group_code' => '13 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'AA',
            'global_service_name' => 'Saturday Delivery',
            'service_group_code' => 'A - NON STANDARD DAY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'AB',
            'global_service_name' => 'Saturday Pickup',
            'service_group_code' => 'A - NON STANDARD DAY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'AC',
            'global_service_name' => 'Holiday Delivery',
            'service_group_code' => 'A - NON STANDARD DAY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'AD',
            'global_service_name' => 'Holiday Pickup',
            'service_group_code' => 'A - NON STANDARD DAY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'AG',
            'global_service_name' => 'Domestic Saturday Delivery',
            'service_group_code' => 'A - NON STANDARD DAY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'BA',
            'global_service_name' => 'Standard',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'BB',
            'global_service_name' => 'Globalmail Item',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'BC',
            'global_service_name' => 'Letter',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'BD',
            'global_service_name' => 'Packet',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'BE',
            'global_service_name' => 'Letter Plus',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'BF',
            'global_service_name' => 'Packet Plus',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'CA',
            'global_service_name' => 'Elevated Risk',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'CB',
            'global_service_name' => 'Restricted Destination',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'CC',
            'global_service_name' => 'Security Validation',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'CD',
            'global_service_name' => 'Secure Protection',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CE',
            'global_service_name' => 'Proof of Identity',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CF',
            'global_service_name' => 'Secure Storage',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CG',
            'global_service_name' => 'Diplomatic Material',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CH',
            'global_service_name' => 'Smart Sensor',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CI',
            'global_service_name' => 'Visa Program',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CJ',
            'global_service_name' => 'Onboard Courier',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CK',
            'global_service_name' => 'Secure Safebox',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CL',
            'global_service_name' => 'Smart Sentry',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'DC',
            'global_service_name' => 'Split Duties & Tax',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'DD',
            'global_service_name' => 'Duties & Taxes Paid',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'DE',
            'global_service_name' => 'Receiver Paid',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'DS',
            'global_service_name' => 'Duties & Taxes Unpaid',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'DT',
            'global_service_name' => 'Import Billing',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'DU',
            'global_service_name' => 'Importer of Record',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'EA',
            'global_service_name' => 'GoGreen Carbon Neutral',
            'service_group_code' => 'E - ENVIRONMENTAL SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'EB',
            'global_service_name' => 'GoGreen Carbon Footprint',
            'service_group_code' => 'E - ENVIRONMENTAL SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'EC',
            'global_service_name' => 'GoGreen Carbon Estimate',
            'service_group_code' => 'E - ENVIRONMENTAL SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'FB',
            'global_service_name' => 'Fuel Surcharge',
            'service_group_code' => 'F - FUEL SURCHARGE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'FC',
            'global_service_name' => 'Fuel Surcharge',
            'service_group_code' => 'F - FUEL SURCHARGE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'FF',
            'global_service_name' => 'Fuel Surcharge',
            'service_group_code' => 'F - FUEL SURCHARGE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'GA',
            'global_service_name' => 'Smartphone Box',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GB',
            'global_service_name' => 'Laptop Box',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GC',
            'global_service_name' => 'Bottle Box',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GD',
            'global_service_name' => 'Repacking',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GE',
            'global_service_name' => 'Tablet Box',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GF',
            'global_service_name' => 'Filler Material',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GG',
            'global_service_name' => 'Packaging',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GH',
            'global_service_name' => 'Diplomatic Bag',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GI',
            'global_service_name' => 'Pallet Box',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GJ',
            'global_service_name' => 'Lock Box',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HC',
            'global_service_name' => 'Dry Ice UN1845',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HD',
            'global_service_name' => 'Lithium Ion PI965-966 Section II',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HE',
            'global_service_name' => 'Dangerous Goods',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HG',
            'global_service_name' => 'Perishable Cargo',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'HH',
            'global_service_name' => 'Excepted Quantity',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HI',
            'global_service_name' => 'Spill Cleaning',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'HK',
            'global_service_name' => 'Consumer Commodities',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HL',
            'global_service_name' => 'Limited Quantities ADR',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HM',
            'global_service_name' => 'Lithium Metal PI969 Section II',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HN',
            'global_service_name' => 'ADR Load Exemption',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HV',
            'global_service_name' => 'Lithium Ion PI967-Section II',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'HW',
            'global_service_name' => 'Lithium Metal PI970-Section II',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'HY',
            'global_service_name' => 'Biological UN3373',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'IB',
            'global_service_name' => 'Extended Liability',
            'service_group_code' => 'I - INSURANCE SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'IC',
            'global_service_name' => 'Contract Insurance',
            'service_group_code' => 'I - INSURANCE SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'II',
            'global_service_name' => 'Shipment Insurance',
            'service_group_code' => 'I - INSURANCE SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'JA',
            'global_service_name' => 'Delivery Notification',
            'service_group_code' => 'J - SHIPMENT NOTIFICATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'JC',
            'global_service_name' => 'Pickup Notification',
            'service_group_code' => 'J - SHIPMENT NOTIFICATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'JD',
            'global_service_name' => 'Proactive Tracking',
            'service_group_code' => 'J - SHIPMENT NOTIFICATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'JE',
            'global_service_name' => 'Performance Reporting',
            'service_group_code' => 'J - SHIPMENT NOTIFICATION',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'JY',
            'global_service_name' => 'Prealert Notification',
            'service_group_code' => 'J - SHIPMENT NOTIFICATION',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'KA',
            'global_service_name' => 'Change of Billing',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'KB',
            'global_service_name' => 'Cash On Delivery',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'KD',
            'global_service_name' => 'Printed Invoice',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'KE',
            'global_service_name' => 'Waybill Copy',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'KF',
            'global_service_name' => 'Import Paperwork',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'KY',
            'global_service_name' => 'Payment on Pickup',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'LA',
            'global_service_name' => 'Shipment Intercept',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'LC',
            'global_service_name' => 'Shipment Redirect',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'LE',
            'global_service_name' => 'Storage at Facility',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'LG',
            'global_service_name' => 'Cold Storage',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'LH',
            'global_service_name' => 'Specific Routing',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'LV',
            'global_service_name' => 'Service Recovery',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'LW',
            'global_service_name' => 'Alternative Address',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'LX',
            'global_service_name' => 'Hold for Collection',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'MA',
            'global_service_name' => 'Address Correction',
            'service_group_code' => 'M - ADDRESS CORRECTION',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'MB',
            'global_service_name' => 'Address Correction',
            'service_group_code' => 'M - ADDRESS CORRECTION',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'NN',
            'global_service_name' => 'Neutral Delivery',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'OB',
            'global_service_name' => 'Remote Area Pickup',
            'service_group_code' => 'O - REMOTE AREA SERVICE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'OC',
            'global_service_name' => 'Remote Area Delivery',
            'service_group_code' => 'O - REMOTE AREA SERVICE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'OE',
            'global_service_name' => 'Out of Service Area',
            'service_group_code' => 'O - REMOTE AREA SERVICE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'OO',
            'global_service_name' => 'Remote Area Delivery',
            'service_group_code' => 'O - REMOTE AREA SERVICE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'PA',
            'global_service_name' => 'Shipment Preparation',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'PB',
            'global_service_name' => 'Shipment Labeling',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'PC',
            'global_service_name' => 'Shipment Consolidation',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'PD',
            'global_service_name' => 'Relabeling/Data Entry',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'PE',
            'global_service_name' => 'Preprinted Waybill',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'PS',
            'global_service_name' => 'Piece Labelling',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'PT',
            'global_service_name' => 'Data Staging 03',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'PU',
            'global_service_name' => 'Data Staging 06',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'PV',
            'global_service_name' => 'Data Staging 12',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'PW',
            'global_service_name' => 'Data Staging 24',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'PX',
            'global_service_name' => 'Standard Pickup',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'PY',
            'global_service_name' => 'Scheduled Pickup',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'QA',
            'global_service_name' => 'Dedicated Pickup',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'QB',
            'global_service_name' => 'Early Pickup',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'QD',
            'global_service_name' => 'Late Pickup',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'QE',
            'global_service_name' => 'Residential Pickup',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'QF',
            'global_service_name' => 'Loading/Waiting',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'QH',
            'global_service_name' => 'Bypass Injection',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'QI',
            'global_service_name' => 'Direct Injection',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'QY',
            'global_service_name' => 'Drop Off at Facility',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'SA',
            'global_service_name' => 'Delivery Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'SB',
            'global_service_name' => 'Content Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'SC',
            'global_service_name' => 'Named Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'SD',
            'global_service_name' => 'Adult Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'SE',
            'global_service_name' => 'Contract Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'SW',
            'global_service_name' => 'Alternative Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'SX',
            'global_service_name' => 'No Signature Required',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TA',
            'global_service_name' => 'Dedicated Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TB',
            'global_service_name' => 'Early Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TC',
            'global_service_name' => 'Time Window Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TD',
            'global_service_name' => 'Evening Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TE',
            'global_service_name' => 'Delivery on Appointment',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TG',
            'global_service_name' => 'Return Undeliverable',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TH',
            'global_service_name' => 'Swap Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TJ',
            'global_service_name' => 'Unloading/Waiting',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'TK',
            'global_service_name' => 'Residential Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'TN',
            'global_service_name' => 'Repeat Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TT',
            'global_service_name' => 'Alternative Date',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TU',
            'global_service_name' => 'No Partial Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TV',
            'global_service_name' => 'Service Point 24/7',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TW',
            'global_service_name' => 'Pre 9:00',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TX',
            'global_service_name' => 'Pre 10:30',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TY',
            'global_service_name' => 'Pre 12:00',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'UA',
            'global_service_name' => 'Thermo Packaging',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'UB',
            'global_service_name' => 'Ambient Vialsafe',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UC',
            'global_service_name' => 'Ambient Non Insulated',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UD',
            'global_service_name' => 'Ambient Insulated',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UE',
            'global_service_name' => 'Ambient Extreme',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UF',
            'global_service_name' => 'Chilled Box S',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UG',
            'global_service_name' => 'Chilled Box M',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UH',
            'global_service_name' => 'Chilled Box L',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UI',
            'global_service_name' => 'Frozen No Ice S',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UJ',
            'global_service_name' => 'Frozen No Ice M',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UK',
            'global_service_name' => 'Frozen No Ice L',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UL',
            'global_service_name' => 'Frozen Ice Sticks S',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UM',
            'global_service_name' => 'Frozen Ice Sticks M',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UN',
            'global_service_name' => 'Frozen Ice Sticks L',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UO',
            'global_service_name' => 'Frozen Ice Plates S',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UP',
            'global_service_name' => 'Frozen Ice Plates M',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UQ',
            'global_service_name' => 'Frozen Ice Plates L',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UR',
            'global_service_name' => 'Combination No Ice',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'US',
            'global_service_name' => 'Combination Dry Ice',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UT',
            'global_service_name' => 'Frozen Ice Sticks E',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UV',
            'global_service_name' => 'Frozen Ice Plates E',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UW',
            'global_service_name' => 'Customer TCP 1',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VA',
            'global_service_name' => 'Thermo Accessories',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'VB',
            'global_service_name' => 'Absorbent Sleeve',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VC',
            'global_service_name' => 'Cooland Wrap',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VD',
            'global_service_name' => 'Dry Ice Supplies',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VE',
            'global_service_name' => 'Pressure Bag S',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VF',
            'global_service_name' => 'Pressure Bag M',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VG',
            'global_service_name' => 'Pressure Bag L',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WA',
            'global_service_name' => 'Informal Clearance',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WB',
            'global_service_name' => 'Formal Clearance',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WC',
            'global_service_name' => 'Payment Deferment',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'WD',
            'global_service_name' => 'Clearance Authorization',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WE',
            'global_service_name' => 'Multiline Entry',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WF',
            'global_service_name' => 'Post Clearance Modification',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WG',
            'global_service_name' => 'Handover to Broker',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WH',
            'global_service_name' => 'Physical Intervention',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'WI',
            'global_service_name' => 'Bio/Phyto/Veterinary Controls',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'WJ',
            'global_service_name' => 'Obtaining Permits & Licences',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WK',
            'global_service_name' => 'Bonded Storage',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'WL',
            'global_service_name' => 'Bonded Transit Documents',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WM',
            'global_service_name' => 'Temporary Import/Export',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WN',
            'global_service_name' => 'Under Bond/Guarantee',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WO',
            'global_service_name' => 'Export Declaration',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WP',
            'global_service_name' => 'Exporter Validation',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WQ',
            'global_service_name' => 'Certificate of Origin',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WR',
            'global_service_name' => 'Document Translation',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WS',
            'global_service_name' => 'Personal Effects',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'WY',
            'global_service_name' => 'Paperless Trade',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'XB',
            'global_service_name' => 'Import Export Taxes',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XC',
            'global_service_name' => 'Unrecoverable Origin Tax',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XD',
            'global_service_name' => 'Quarantine Inspection',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XE',
            'global_service_name' => 'Merchandise Process',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XF',
            'global_service_name' => 'Domestic Postal Tax',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XG',
            'global_service_name' => 'Tier Two Tax',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XH',
            'global_service_name' => 'Tier Three Tax',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XI',
            'global_service_name' => 'Import Penalty',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XJ',
            'global_service_name' => 'Cargo Zone Process',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XX',
            'global_service_name' => 'Import / Export Duties',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'Y1',
            'global_service_name' => '09:00 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'Y2',
            'global_service_name' => '10:30 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'Y3',
            'global_service_name' => '12:00 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YB',
            'global_service_name' => 'Over Sized Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YC',
            'global_service_name' => 'Over Handled Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YE',
            'global_service_name' => 'Multipiece Shipment',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YF',
            'global_service_name' => 'Over Weight Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YG',
            'global_service_name' => 'Over Sized Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YH',
            'global_service_name' => 'Over Handled Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YI',
            'global_service_name' => '9:00 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YJ',
            'global_service_name' => '10:30 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YK',
            'global_service_name' => '12:00 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YV',
            'global_service_name' => 'Paket Shipment',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'YW',
            'global_service_name' => 'Breakbulk Mother',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'YX',
            'global_service_name' => 'Breakbulk Baby',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'YY',
            'global_service_name' => 'Over Weight Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'ZA',
            'global_service_name' => 'Customer Claim',
            'service_group_code' => 'Z - UNRECOVERABLE ORIGIN TAX',
            'charge_code_type_code' => 'CRE - Credit Items',
        ),
        array(
            'special_service_code' => 'ZB',
            'global_service_name' => 'Damage Compensation',
            'service_group_code' => 'Z - UNRECOVERABLE ORIGIN TAX',
            'charge_code_type_code' => 'CRE - Credit Items',
        ),
        array(
            'special_service_code' => 'ZC',
            'global_service_name' => 'Loss Compensation',
            'service_group_code' => 'Z - UNRECOVERABLE ORIGIN TAX',
            'charge_code_type_code' => 'CRE - Credit Items',
        ),
        array(
            'special_service_code' => 'ZD',
            'global_service_name' => 'Customer Rebate',
            'service_group_code' => 'Z - UNRECOVERABLE ORIGIN TAX',
            'charge_code_type_code' => 'CRE - Credit Items',
        ),
        array(
            'special_service_code' => 'ZE',
            'global_service_name' => 'eCom Discount',
            'service_group_code' => 'Z - UNRECOVERABLE ORIGIN TAX',
            'charge_code_type_code' => 'CRE - Credit Items',
        ),
    ); //}}}

    protected static $DHL_terms_of_trade = array( //{{{
        array(
            'code' => 'EXW',
            'description' => 'Ex Works',
            'definition' => 'The seller\'s only obligation is to make the goods available at its premises or at another named place (works, factory, warehouse, etc.). The buyer bears all costs and risks involved in taking the goods from the seller�s premises to the desired destination. This term represents the minimum obligation for the seller.',
        ),
        array(
            'code' => 'FCA',
            'description' => 'Free Carrier',
            'definition' => 'The seller�s obligation is to hand over the goods, cleared for export, into�the charge of the carrier named by the buyer at the named place or point.�The parties are advised to specify as clearly as possible the point within the named place of delivery, as the risk passes to the buyer at that point.',
        ),
        array(
            'code' => 'CPT',
            'description' => 'Carriage Paid To',
            'definition' => 'The seller pays the freight for the delivery of goods to the carrier or to another person nominated by the seller at the named destination. Once delivered, the risk of loss or damage to the goods is transferred from the seller to the buyer. This term requires the seller to clear the goods for export.',
        ),
        array(
            'code' => 'CIP',
            'description' => 'Carriage and Insurance Paid To',
            'definition' => 'The seller has the same obligations as under CPT but has the responsibility of obtaining insurance against the buyer�s risk of loss or damage to goods during carriage. Insurance only needs to be obtained at minimum coverage and the seller is required to clear the goods for export.',
        ),
        array(
            'code' => 'DAT',
            'description' => 'Delivered At Terminal',
            'definition' => 'The seller delivers when the goods, once unloaded from the arriving means of transport, are placed at the disposal of the buyer at a named terminal at the named port or place of destination. �Terminal� includes quay, warehouse, container yard or road, rail or air terminal. The seller is responsible for the export clearance procedures and the importer is responsible for clearing the goods for import, arranging import customs formalities, and paying import duty.',
        ),
        array(
            'code' => 'DAP',
            'description' => 'Delivered At Place',
            'definition' => 'The seller delivers when the goods are placed at the disposal of thebuyer on the arriving means of transport ready for unloading at the named place of destination. The seller is required to clear the goods for export and the importer is responsible for effecting customs clearance, and paying any customs duties.',
        ),
        array(
            'code' => 'DDP',
            'description' => 'Delivered Duty Paid',
            'definition' => 'The seller is responsible for delivering the goods to the named place in the country of importation, including all costs and risks in bringing the goods to import destination. This includes all export and import duties, taxes and customs formalities.',
        ),
    ); //}}}

    protected static $DHL_special_services = array( //{{{
        array(
            'special_service_code' => '0A',
            'global_service_name' => 'Logistics Services',
            'service_group_code' => '0 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0B',
            'global_service_name' => 'Mailroom Management',
            'service_group_code' => '1 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0C',
            'global_service_name' => 'Pallet Administration',
            'service_group_code' => '2 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0D',
            'global_service_name' => 'Warehousing',
            'service_group_code' => '3 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0E',
            'global_service_name' => 'Express Logistics Centre',
            'service_group_code' => '4 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0F',
            'global_service_name' => 'Strategic Parts Centre',
            'service_group_code' => '5 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0G',
            'global_service_name' => 'Local Distribution Centre',
            'service_group_code' => '6 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0H',
            'global_service_name' => 'Terminal Handling',
            'service_group_code' => '7 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0I',
            'global_service_name' => 'Cross Docking',
            'service_group_code' => '8 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0J',
            'global_service_name' => 'Inventory Management',
            'service_group_code' => '9 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0K',
            'global_service_name' => 'Loading/Unloading',
            'service_group_code' => '10 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0L',
            'global_service_name' => 'Product Kitting',
            'service_group_code' => '11 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0M',
            'global_service_name' => 'Priority Account Desk',
            'service_group_code' => '12 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => '0N',
            'global_service_name' => 'Document Archiving',
            'service_group_code' => '13 - LOGISTICS SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'AA',
            'global_service_name' => 'Saturday Delivery',
            'service_group_code' => 'A - NON STANDARD DAY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'AB',
            'global_service_name' => 'Saturday Pickup',
            'service_group_code' => 'A - NON STANDARD DAY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'AC',
            'global_service_name' => 'Holiday Delivery',
            'service_group_code' => 'A - NON STANDARD DAY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'AD',
            'global_service_name' => 'Holiday Pickup',
            'service_group_code' => 'A - NON STANDARD DAY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'AG',
            'global_service_name' => 'Domestic Saturday Delivery',
            'service_group_code' => 'A - NON STANDARD DAY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'BA',
            'global_service_name' => 'Standard',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'BB',
            'global_service_name' => 'Globalmail Item',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'BC',
            'global_service_name' => 'Letter',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'BD',
            'global_service_name' => 'Packet',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'BE',
            'global_service_name' => 'Letter Plus',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'BF',
            'global_service_name' => 'Packet Plus',
            'service_group_code' => 'B - GLOBALMAIL ITEM',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'CA',
            'global_service_name' => 'Elevated Risk',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'CB',
            'global_service_name' => 'Restricted Destination',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'CC',
            'global_service_name' => 'Security Validation',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'CD',
            'global_service_name' => 'Secure Protection',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CE',
            'global_service_name' => 'Proof of Identity',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CF',
            'global_service_name' => 'Secure Storage',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CG',
            'global_service_name' => 'Diplomatic Material',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CH',
            'global_service_name' => 'Smart Sensor',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CI',
            'global_service_name' => 'Visa Program',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CJ',
            'global_service_name' => 'Onboard Courier',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CK',
            'global_service_name' => 'Secure Safebox',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'CL',
            'global_service_name' => 'Smart Sentry',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'DC',
            'global_service_name' => 'Split Duties & Tax',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'DD',
            'global_service_name' => 'Duties & Taxes Paid',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'DE',
            'global_service_name' => 'Receiver Paid',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'DS',
            'global_service_name' => 'Duties & Taxes Unpaid',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'DT',
            'global_service_name' => 'Import Billing',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'DU',
            'global_service_name' => 'Importer of Record',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'EA',
            'global_service_name' => 'GoGreen Carbon Neutral',
            'service_group_code' => 'E - ENVIRONMENTAL SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'EB',
            'global_service_name' => 'GoGreen Carbon Footprint',
            'service_group_code' => 'E - ENVIRONMENTAL SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'EC',
            'global_service_name' => 'GoGreen Carbon Estimate',
            'service_group_code' => 'E - ENVIRONMENTAL SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'FB',
            'global_service_name' => 'Fuel Surcharge',
            'service_group_code' => 'F - FUEL SURCHARGE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'FC',
            'global_service_name' => 'Fuel Surcharge',
            'service_group_code' => 'F - FUEL SURCHARGE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'FF',
            'global_service_name' => 'Fuel Surcharge',
            'service_group_code' => 'F - FUEL SURCHARGE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'GA',
            'global_service_name' => 'Smartphone Box',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GB',
            'global_service_name' => 'Laptop Box',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GC',
            'global_service_name' => 'Bottle Box',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GD',
            'global_service_name' => 'Repacking',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GE',
            'global_service_name' => 'Tablet Box',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GF',
            'global_service_name' => 'Filler Material',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GG',
            'global_service_name' => 'Packaging',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GH',
            'global_service_name' => 'Diplomatic Bag',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GI',
            'global_service_name' => 'Pallet Box',
            'service_group_code' => 'G - PACKAGING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'GJ',
            'global_service_name' => 'Lock Box',
            'service_group_code' => 'C - SECURITY SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HC',
            'global_service_name' => 'Dry Ice UN1845',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HD',
            'global_service_name' => 'Lithium Ion PI965-966 Section II',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HE',
            'global_service_name' => 'Dangerous Goods',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HG',
            'global_service_name' => 'Perishable Cargo',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'HH',
            'global_service_name' => 'Excepted Quantity',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HI',
            'global_service_name' => 'Spill Cleaning',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'HK',
            'global_service_name' => 'Consumer Commodities',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HL',
            'global_service_name' => 'Limited Quantities ADR',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HM',
            'global_service_name' => 'Lithium Metal PI969 Section II',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HN',
            'global_service_name' => 'ADR Load Exemption',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'HV',
            'global_service_name' => 'Lithium Ion PI967-Section II',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'HW',
            'global_service_name' => 'Lithium Metal PI970-Section II',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'HY',
            'global_service_name' => 'Biological UN3373',
            'service_group_code' => 'H - NON STANDARD CONTENTS',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'IB',
            'global_service_name' => 'Extended Liability',
            'service_group_code' => 'I - INSURANCE SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'IC',
            'global_service_name' => 'Contract Insurance',
            'service_group_code' => 'I - INSURANCE SERVICES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'II',
            'global_service_name' => 'Shipment Insurance',
            'service_group_code' => 'I - INSURANCE SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'JA',
            'global_service_name' => 'Delivery Notification',
            'service_group_code' => 'J - SHIPMENT NOTIFICATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'JC',
            'global_service_name' => 'Pickup Notification',
            'service_group_code' => 'J - SHIPMENT NOTIFICATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'JD',
            'global_service_name' => 'Proactive Tracking',
            'service_group_code' => 'J - SHIPMENT NOTIFICATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'JE',
            'global_service_name' => 'Performance Reporting',
            'service_group_code' => 'J - SHIPMENT NOTIFICATION',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'JY',
            'global_service_name' => 'Prealert Notification',
            'service_group_code' => 'J - SHIPMENT NOTIFICATION',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'KA',
            'global_service_name' => 'Change of Billing',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'KB',
            'global_service_name' => 'Cash On Delivery',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'KD',
            'global_service_name' => 'Printed Invoice',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'KE',
            'global_service_name' => 'Waybill Copy',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'KF',
            'global_service_name' => 'Import Paperwork',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'KY',
            'global_service_name' => 'Payment on Pickup',
            'service_group_code' => 'K - BILLING INSTRUCTIONS',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'LA',
            'global_service_name' => 'Shipment Intercept',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'LC',
            'global_service_name' => 'Shipment Redirect',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'LE',
            'global_service_name' => 'Storage at Facility',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'LG',
            'global_service_name' => 'Cold Storage',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'LH',
            'global_service_name' => 'Specific Routing',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'LV',
            'global_service_name' => 'Service Recovery',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'LW',
            'global_service_name' => 'Alternative Address',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'LX',
            'global_service_name' => 'Hold for Collection',
            'service_group_code' => 'L - SHIPMENT INTERCEPT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'MA',
            'global_service_name' => 'Address Correction',
            'service_group_code' => 'M - ADDRESS CORRECTION',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'MB',
            'global_service_name' => 'Address Correction',
            'service_group_code' => 'M - ADDRESS CORRECTION',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'NN',
            'global_service_name' => 'Neutral Delivery',
            'service_group_code' => 'D - BILLING SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'OB',
            'global_service_name' => 'Remote Area Pickup',
            'service_group_code' => 'O - REMOTE AREA SERVICE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'OC',
            'global_service_name' => 'Remote Area Delivery',
            'service_group_code' => 'O - REMOTE AREA SERVICE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'OE',
            'global_service_name' => 'Out of Service Area',
            'service_group_code' => 'O - REMOTE AREA SERVICE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'OO',
            'global_service_name' => 'Remote Area Delivery',
            'service_group_code' => 'O - REMOTE AREA SERVICE',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'PA',
            'global_service_name' => 'Shipment Preparation',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'PB',
            'global_service_name' => 'Shipment Labeling',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'PC',
            'global_service_name' => 'Shipment Consolidation',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'PD',
            'global_service_name' => 'Relabeling/Data Entry',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'PE',
            'global_service_name' => 'Preprinted Waybill',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'PS',
            'global_service_name' => 'Piece Labelling',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'PT',
            'global_service_name' => 'Data Staging 03',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'PU',
            'global_service_name' => 'Data Staging 06',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'PV',
            'global_service_name' => 'Data Staging 12',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'PW',
            'global_service_name' => 'Data Staging 24',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'PX',
            'global_service_name' => 'Standard Pickup',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'PY',
            'global_service_name' => 'Scheduled Pickup',
            'service_group_code' => 'P - SHIPMENT PREPARATION',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'QA',
            'global_service_name' => 'Dedicated Pickup',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'QB',
            'global_service_name' => 'Early Pickup',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'QD',
            'global_service_name' => 'Late Pickup',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'QE',
            'global_service_name' => 'Residential Pickup',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'QF',
            'global_service_name' => 'Loading/Waiting',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'QH',
            'global_service_name' => 'Bypass Injection',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'QI',
            'global_service_name' => 'Direct Injection',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'QY',
            'global_service_name' => 'Drop Off at Facility',
            'service_group_code' => 'Q - NON STANDARD PICKUP',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'SA',
            'global_service_name' => 'Delivery Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'SB',
            'global_service_name' => 'Content Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'SC',
            'global_service_name' => 'Named Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'SD',
            'global_service_name' => 'Adult Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'SE',
            'global_service_name' => 'Contract Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'SW',
            'global_service_name' => 'Alternative Signature',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'SX',
            'global_service_name' => 'No Signature Required',
            'service_group_code' => 'S - SIGNATURE SERVICE',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TA',
            'global_service_name' => 'Dedicated Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TB',
            'global_service_name' => 'Early Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TC',
            'global_service_name' => 'Time Window Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TD',
            'global_service_name' => 'Evening Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TE',
            'global_service_name' => 'Delivery on Appointment',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TG',
            'global_service_name' => 'Return Undeliverable',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TH',
            'global_service_name' => 'Swap Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'TJ',
            'global_service_name' => 'Unloading/Waiting',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'TK',
            'global_service_name' => 'Residential Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'TN',
            'global_service_name' => 'Repeat Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TT',
            'global_service_name' => 'Alternative Date',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TU',
            'global_service_name' => 'No Partial Delivery',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TV',
            'global_service_name' => 'Service Point 24/7',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TW',
            'global_service_name' => 'Pre 9:00',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TX',
            'global_service_name' => 'Pre 10:30',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'TY',
            'global_service_name' => 'Pre 12:00',
            'service_group_code' => 'T - NON STANDARD DELIVERY',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'UA',
            'global_service_name' => 'Thermo Packaging',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'UB',
            'global_service_name' => 'Ambient Vialsafe',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UC',
            'global_service_name' => 'Ambient Non Insulated',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UD',
            'global_service_name' => 'Ambient Insulated',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UE',
            'global_service_name' => 'Ambient Extreme',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UF',
            'global_service_name' => 'Chilled Box S',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UG',
            'global_service_name' => 'Chilled Box M',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UH',
            'global_service_name' => 'Chilled Box L',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UI',
            'global_service_name' => 'Frozen No Ice S',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UJ',
            'global_service_name' => 'Frozen No Ice M',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UK',
            'global_service_name' => 'Frozen No Ice L',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UL',
            'global_service_name' => 'Frozen Ice Sticks S',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UM',
            'global_service_name' => 'Frozen Ice Sticks M',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UN',
            'global_service_name' => 'Frozen Ice Sticks L',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UO',
            'global_service_name' => 'Frozen Ice Plates S',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UP',
            'global_service_name' => 'Frozen Ice Plates M',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UQ',
            'global_service_name' => 'Frozen Ice Plates L',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UR',
            'global_service_name' => 'Combination No Ice',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'US',
            'global_service_name' => 'Combination Dry Ice',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UT',
            'global_service_name' => 'Frozen Ice Sticks E',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UV',
            'global_service_name' => 'Frozen Ice Plates E',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'UW',
            'global_service_name' => 'Customer TCP 1',
            'service_group_code' => 'U - PAYMENT DEFERMENT',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VA',
            'global_service_name' => 'Thermo Accessories',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'FEE - Fees',
        ),
        array(
            'special_service_code' => 'VB',
            'global_service_name' => 'Absorbent Sleeve',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VC',
            'global_service_name' => 'Cooland Wrap',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VD',
            'global_service_name' => 'Dry Ice Supplies',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VE',
            'global_service_name' => 'Pressure Bag S',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VF',
            'global_service_name' => 'Pressure Bag M',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'VG',
            'global_service_name' => 'Pressure Bag L',
            'service_group_code' => 'V - THERMO ACCESSORIES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WA',
            'global_service_name' => 'Informal Clearance',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WB',
            'global_service_name' => 'Formal Clearance',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WC',
            'global_service_name' => 'Payment Deferment',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'WD',
            'global_service_name' => 'Clearance Authorization',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WE',
            'global_service_name' => 'Multiline Entry',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WF',
            'global_service_name' => 'Post Clearance Modification',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WG',
            'global_service_name' => 'Handover to Broker',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WH',
            'global_service_name' => 'Physical Intervention',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'WI',
            'global_service_name' => 'Bio/Phyto/Veterinary Controls',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'WJ',
            'global_service_name' => 'Obtaining Permits & Licences',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WK',
            'global_service_name' => 'Bonded Storage',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'WL',
            'global_service_name' => 'Bonded Transit Documents',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WM',
            'global_service_name' => 'Temporary Import/Export',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WN',
            'global_service_name' => 'Under Bond/Guarantee',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WO',
            'global_service_name' => 'Export Declaration',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WP',
            'global_service_name' => 'Exporter Validation',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WQ',
            'global_service_name' => 'Certificate of Origin',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WR',
            'global_service_name' => 'Document Translation',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'XCH - Extra Charges',
        ),
        array(
            'special_service_code' => 'WS',
            'global_service_name' => 'Personal Effects',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'WY',
            'global_service_name' => 'Paperless Trade',
            'service_group_code' => 'W - CUSTOMS SERVICES',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'XB',
            'global_service_name' => 'Import Export Taxes',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XC',
            'global_service_name' => 'Unrecoverable Origin Tax',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XD',
            'global_service_name' => 'Quarantine Inspection',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XE',
            'global_service_name' => 'Merchandise Process',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XF',
            'global_service_name' => 'Domestic Postal Tax',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XG',
            'global_service_name' => 'Tier Two Tax',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XH',
            'global_service_name' => 'Tier Three Tax',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XI',
            'global_service_name' => 'Import Penalty',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XJ',
            'global_service_name' => 'Cargo Zone Process',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'XX',
            'global_service_name' => 'Import / Export Duties',
            'service_group_code' => 'X - IMPORT/EXPORT DUTIES',
            'charge_code_type_code' => 'FIS - Fiscal Features',
        ),
        array(
            'special_service_code' => 'Y1',
            'global_service_name' => '09:00 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'Y2',
            'global_service_name' => '10:30 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'Y3',
            'global_service_name' => '12:00 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YB',
            'global_service_name' => 'Over Sized Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YC',
            'global_service_name' => 'Over Handled Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YE',
            'global_service_name' => 'Multipiece Shipment',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YF',
            'global_service_name' => 'Over Weight Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YG',
            'global_service_name' => 'Over Sized Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YH',
            'global_service_name' => 'Over Handled Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YI',
            'global_service_name' => '9:00 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YJ',
            'global_service_name' => '10:30 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YK',
            'global_service_name' => '12:00 Premium',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'YV',
            'global_service_name' => 'Paket Shipment',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'YW',
            'global_service_name' => 'Breakbulk Mother',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'YX',
            'global_service_name' => 'Breakbulk Baby',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'INC - Included',
        ),
        array(
            'special_service_code' => 'YY',
            'global_service_name' => 'Over Weight Piece',
            'service_group_code' => 'Y - NON STANDARD SHIPMENT',
            'charge_code_type_code' => 'SCH - Surcharges',
        ),
        array(
            'special_service_code' => 'ZA',
            'global_service_name' => 'Customer Claim',
            'service_group_code' => 'Z - UNRECOVERABLE ORIGIN TAX',
            'charge_code_type_code' => 'CRE - Credit Items',
        ),
        array(
            'special_service_code' => 'ZB',
            'global_service_name' => 'Damage Compensation',
            'service_group_code' => 'Z - UNRECOVERABLE ORIGIN TAX',
            'charge_code_type_code' => 'CRE - Credit Items',
        ),
        array(
            'special_service_code' => 'ZC',
            'global_service_name' => 'Loss Compensation',
            'service_group_code' => 'Z - UNRECOVERABLE ORIGIN TAX',
            'charge_code_type_code' => 'CRE - Credit Items',
        ),
        array(
            'special_service_code' => 'ZD',
            'global_service_name' => 'Customer Rebate',
            'service_group_code' => 'Z - UNRECOVERABLE ORIGIN TAX',
            'charge_code_type_code' => 'CRE - Credit Items',
        ),
        array(
            'special_service_code' => 'ZE',
            'global_service_name' => 'eCom Discount',
            'service_group_code' => 'Z - UNRECOVERABLE ORIGIN TAX',
            'charge_code_type_code' => 'CRE - Credit Items',
        ),
    ); //}}}

    protected static $DHL_regions = array ( //{{{
        'AM' => array(
            'AI', 'AR', 'AW', 'BB', 'BM', 'BO', 'BR', 'BS', 'CA', 'CL', 'CO',
            'CR', 'DM', 'DO', 'EC', 'GP', 'GT', 'GU', 'GY', 'HN', 'HT', 'JM',
            'KN', 'KY', 'LC', 'MQ', 'MX', 'NI', 'PA', 'PE', 'PR', 'PY', 'SV',
            'TC', 'TT', 'US', 'UY', 'VE', 'VG', 'VI', 'XM', 'XY',
        ),
        'AP' => array(
            'AE', 'AF', 'AL', 'AM', 'AO', 'AU', 'BA', 'BD', 'BH', 'BN', 'BY',
            'CI', 'CM', 'CN', 'CY', 'DJ', 'DZ', 'EG', 'ET', 'FJ', 'GA', 'GH',
            'HK', 'HR', 'ID', 'IL', 'IN', 'IR', 'JO', 'JP', 'KE', 'KR', 'KW',
            'KZ', 'LA', 'LB', 'LK', 'MA', 'MD', 'MG', 'MK', 'MO', 'MT', 'MU',
            'MY', 'NA', 'NG', 'NZ', 'OM', 'PH', 'PK', 'QA', 'RE', 'RS', 'RU',
            'SA', 'SD', 'SG', 'SN', 'TH', 'TR', 'TW', 'TZ', 'UA', 'UG', 'UZ',
            'VN', 'YE', 'ZA',
        ),
        'EU' => array(
            'AT', 'BE', 'BG', 'CH', 'CZ', 'DE', 'DK', 'EE', 'ES', 'FI', 'FR',
            'GB', 'GR', 'HU', 'IE', 'IS', 'IT', 'LT', 'LU', 'LV', 'NL', 'NO',
            'PL', 'PT', 'RO', 'SE', 'SI', 'SK',
        ),
    ); //}}}

    protected static function findObjectByCode(&$container, $key, $code)
    { //{{{
        $result = array();

        foreach ($container as $value) {
            if ($value[$key] === $code ) {
                $result = $value;
                break;
            }
        }

        return $result;
    } //}}}

    public static function getAllCountries()
    { //{{{
        return self::$DHL_countries;
    } //}}}

    public static function getCountryInfo($code)
    { //{{{
        return static::findObjectByCode(self::$DHL_countries, 'country_code', $code);
    } //}}}

    public static function getAllProducts()
    { //{{{
        return self::$DHL_products;
    } //}}}

    public static function getProductInfo($code)
    { //{{{
        return static::findObjectByCode(self::$DHL_products, 'global_product_code', $code);
    } //}}}

    public static function getAllServices()
    { //{{{
        return self::$DHL_services;
    } //}}}

    public static function getServiceInfo($code)
    { //{{{
        return static::findObjectByCode(self::$DHL_services, 'special_service_code', $code);
    } //}}}

    public static function getAllTermsOfTrade()
    { //{{{
        return self::$DHL_terms_of_trade;
    } //}}}

    public static function getTermOfTradeInfo($code)
    { //{{{
        return static::findObjectByCode(self::$DHL_terms_of_trade, 'code', $code);
    } //}}}

    public static function getAllSpecialServices()
    { //{{{
        return self::$DHL_special_services;
    } //}}}

    public static function getSpecialServiceInfo($code)
    { //{{{
        return static::findObjectByCode(self::$DHL_special_services, 'code', $code);
    } //}}}

    public static function getAllRegions()
    { //{{{
        return array_keys(self::$DHL_regions);
    } //}}}

    public static function getRegionByCountry($code)
    { //{{{
        foreach (self::$DHL_regions as $rcode => $rlist) {
            if (in_array($code, $rlist)) {
                return $rcode;
            }
        }
        return '';
    } //}}}

    public static function getAllCurrencies()
    { //{{{
        // X_PHP550_COMPAT {{{
        global $xcart_dir;
        require_once $xcart_dir . '/include/lib/Compability/array_column/array_column.php';
        // X_PHP550_COMPAT }}}

        $currencies = array_unique(
            array_combine(
                array_column(self::$DHL_countries, 'currency_code'),
                array_column(self::$DHL_countries, 'currency')
            )
        );
        ksort($currencies);
        return $currencies;
    } //}}}

} //}}}

?>
